<?php
/**
 * Map settings meta box.
 *
 * @package Treweler/Admin
 */

if ( ! defined( 'ABSPATH' ) ) {
  exit;
}

$post_id = isset( $post->ID ) ? $post->ID : '';
$custom_color = get_option( 'treweler_mapbox_colorpicker_custom_color' );
$defaultColors = '#F44336|#EC407A|#E046C6|#B94AEF|#8559FF|#317DFC|#426D7E|#027F71|#008A43|#238C28|#4B7715|#756B11|#C06018|#9B5A45|#505050|#00B0F6|#00C5AF|#00BC5B|#18AF1F|#5DA900|#A19100|#FF7814|#FF5D28|#FFFFFF|#000000|';

$post_meta_old = get_post_meta( $post_id );

$prefix = '_treweler_';

$meta_data = twer_get_data( $post_id );


$styles = isset( $post_meta_old["_treweler_map_styles"] ) ? trim( $post_meta_old["_treweler_map_styles"][0] ) : "";
$map_cust_style = isset( $post_meta_old["_treweler_map_custom_style"] ) ? $post_meta_old["_treweler_map_custom_style"][0] : "";

$map_ll = isset( $post_meta_old["_treweler_map_latlng"] ) ? unserialize( $post_meta_old["_treweler_map_latlng"][0] ) : [];
if ( ! empty( $map_ll ) ) {
  foreach ( $map_ll as $k => $v ) {
    ${"ll$k"} = $v;
  }
}

$map_zoom = isset( $post_meta_old["_treweler_map_zoom"] ) ? $post_meta_old["_treweler_map_zoom"][0] : 0;
$map_min_zoom = isset( $post_meta_old["_treweler_map_min_zoom"] ) ? $post_meta_old["_treweler_map_min_zoom"][0] : 0;
$map_max_zoom = isset( $post_meta_old["_treweler_map_max_zoom"] ) ? $post_meta_old["_treweler_map_max_zoom"][0] : 24;

$cluster_color = isset( $post_meta_old["_treweler_map_cluster_color"] ) ? $post_meta_old["_treweler_map_cluster_color"][0] : '#4b7715';
$post_meta_oldom_color = get_option( 'treweler_mapbox_colorpicker_custom_color' );
$defaultColors = "#F44336|#EC407A|#E046C6|#B94AEF|#8559FF|#317DFC|#426D7E|#027F71|#008A43|#238C28|#4B7715|#756B11|#C06018|#9B5A45|#505050|#00B0F6|#00C5AF|#00BC5B|#18AF1F|#5DA900|#A19100|#FF7814|#FF5D28|#FFFFFF|#000000|";

?>
<div class="twer-root_">
    <div class="twer-settings">
        <div class="twer-settings__body">
            <div class="container-fluid">
                <div class="treweler-controls">

                    <p class="post-attributes-label-wrapper"><label class="post-attributes-label">
                        <?php echo esc_html__( "Styles", 'treweler' ); ?></label>
                    </p>
                    <p>
                        <select name="_treweler_map_styles" id="map_styles" class="large-select">
                            <option value="mapbox://styles/mapbox/streets-v11" <?php echo( $styles == "mapbox://styles/mapbox/streets-v11" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Streets',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/outdoors-v11" <?php echo( $styles == "mapbox://styles/mapbox/outdoors-v11" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Outdoors',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/light-v10" <?php echo( $styles == "mapbox://styles/mapbox/light-v10" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Streets Light',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/dark-v10" <?php echo( $styles == "mapbox://styles/mapbox/dark-v10" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Streets Dark',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/satellite-v9" <?php echo( $styles == "mapbox://styles/mapbox/satellite-v9" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Satellite',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/satellite-streets-v11" <?php echo( $styles == "mapbox://styles/mapbox/satellite-streets-v11" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Satellite Streets',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/navigation-preview-day-v4" <?php echo( $styles == "mapbox://styles/mapbox/navigation-preview-day-v4" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Navigations Preview Day',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/navigation-preview-night-v4" <?php echo( $styles == "mapbox://styles/mapbox/navigation-preview-night-v4" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Navigations Preview Night',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/navigation-guidance-day-v4" <?php echo( $styles == "mapbox://styles/mapbox/navigation-guidance-day-v4" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Navigations Guidance Day',
                                'treweler' ); ?></option>
                            <option value="mapbox://styles/mapbox/navigation-guidance-night-v4" <?php echo( $styles == "mapbox://styles/mapbox/navigation-guidance-night-v4" ? 'selected' : '' ); ?>><?php echo esc_html__( 'Navigations Guidance Night',
                                'treweler' ); ?></option>
                        </select>
                    </p>
                    <hr/>
                    <p class="post-attributes-label-wrapper"><label class="post-attributes-label">
                        <?php echo esc_html__( "Custom Style", 'treweler' ); ?></label>
                    </p>
                    <p><input type="text" name="_treweler_map_custom_style" id="custom_style" class="large-text"
                              value="<?php echo esc_attr( $map_cust_style ); ?>"
                              placeholder="<?php echo esc_attr__( "E.g. mapbox://styles/username/*", 'treweler' ); ?>"/>
                    </p>
                    <hr/>
                    <p class="post-attributes-label-wrapper">
                        <label class="post-attributes-label">
                          <?php echo esc_html__( "Initial Point", 'treweler' ); ?>
                        </label>
                    </p>
                    <p><input type="text" name="_treweler_map_latlng[0]" id="latitude" class="large-text"
                              value="<?php echo esc_attr( ( isset( $ll0 ) ? $ll0 : 40.730610 ) ); ?>"
                              placeholder="<?php echo esc_attr__( "Latitude ", 'treweler' ); ?>"/></p>
                    <p><input type="text" name="_treweler_map_latlng[1]" id="longitude" class="large-text"
                              value="<?php echo esc_attr( ( isset( $ll1 ) ? $ll1 : - 73.935242 ) ); ?>"
                              placeholder="<?php echo esc_attr__( "Longitude", 'treweler' ); ?>"/></p>
                    <p>
                        <input type="hidden" name="_treweler_map_latlng_prev" value="">
                        <input type="checkbox" name="_treweler_map_latlng_prev" id="latlng_map_prev"
                               value="1" <?php checked( isset( $meta_data->map_latlng_prev ) ? $meta_data->map_latlng_prev : is_int( $post_id ) ); ?>><?php echo esc_html__( "Use the map preview",
                        'treweler' ); ?>
                    </p>

                    <p>
                        <input type="hidden" name="_treweler_map_geoposition" value="">
                        <input type="checkbox" name="_treweler_map_geoposition" id="_treweler_map_geoposition"
                               value="1" <?php checked( isset( $meta_data->map_geoposition ) ? $meta_data->map_geoposition : '' ); ?>>
                      <?php echo esc_html__( "Use user's current location", 'treweler' ); ?>
                    </p>

                    <hr/>
                    <p class="post-attributes-label-wrapper"><label
                                class="post-attributes-label"><?php echo esc_html__( "Initial Zoom Level",
                          'treweler' ); ?></label></p>
                    <p>
                        <input type="range" step="0.01" min="<?php echo esc_attr( $map_min_zoom ); ?>"
                               max="<?php echo esc_attr( $map_max_zoom ); ?>" name="default_zoom_range"
                               id="setZoom_range" class="large-text" value="<?php echo esc_attr( $map_zoom ); ?>"/>
                        <input type="number" step="0.01" min="<?php echo esc_attr( $map_min_zoom ); ?>"
                               max="<?php echo esc_attr( $map_max_zoom ); ?>" name="_treweler_map_zoom" id="setZoom"
                               class="large-text" value="<?php echo esc_attr( $map_zoom ); ?>"/>
                    </p>
                    <p class="zoom-map-prev-chk">
                        <input type="hidden" name="_treweler_map_zoom_prev" value="">
                        <input type="checkbox" name="_treweler_map_zoom_prev" id="zoom_map_prev"
                               value="1" <?php checked( isset( $meta_data->map_zoom_prev ) ? $meta_data->map_zoom_prev : is_int( $post_id ) ); ?>>
                      <?php echo esc_html__( "Use the map preview", 'treweler' ); ?>
                    </p>
                    <hr/>
                    <p class="post-attributes-label-wrapper">
                        <label class="post-attributes-label">
                          <?php echo esc_html__( "Zoom Range", 'treweler' ); ?>
                        </label>
                    </p>
                    <p class="multirange">
                        <input type="range" step="0.01" min="0" max="24" name="_treweler_map_min_zoom"
                               id="setZoom_min_range" class="large-text lower-slider"
                               value="<?php echo esc_attr( $map_min_zoom ); ?>"/>
                        <input type="range" step="0.01" min="0" max="24" name="_treweler_map_max_zoom"
                               id="setZoom_max_range" class="large-text upper-slider"
                               value="<?php echo esc_attr( $map_max_zoom ); ?>"/>
                    </p>
                    <p class="zoom-ctrl-label">
                        <input type="number" step="0.01" min="0" max="24" id="default_min_zoom" class="alighleft"
                               value="<?php echo esc_attr( $map_min_zoom ); ?>"/>
                        <input type="number" step="0.01" min="0" max="24" id="default_max_zoom" class="alignright"
                               value="<?php echo esc_attr( $map_max_zoom ); ?>"/>
                    </p>

                    <hr>
                    <p class="post-attributes-label-wrapper">
                        <label class="post-attributes-label">
                          <?php echo esc_html__( "Overlay Color", 'treweler' ); ?>
                        </label>
                    </p>


                  <?php

                  $overlay = isset( $post_meta_old["_treweler_bg_overlay"] ) ? trim( $post_meta_old["_treweler_bg_overlay"][0] ) : "rgba(255,255,255,0)";

                  ?>

                    <div class="clearfix">
                        <div id="overlay-style-map" class="js-twer-color-picker-wrap-o twer-color-picker-wrap" style="float: left;">
                            <div class="map-text-color js-twer-color-picker-o">
                                                                <span class="color-holder"
                                                                      style="background-color:<?php echo esc_attr( $overlay ) ?>;"></span>
                                <input type="button" style="margin: 0;" class="text-color-picker-btn"
                                       value="<?php echo esc_attr__( 'Select Color',
                                         'treweler' ); ?>">
                            </div>
                            <!-- .color-picker-text-descr -->
                            <div style="position: absolute; left: 0;   bottom: 33px;" class="js-twer-color-picker-palette-o twer-color-picker-palette"
                                 acp-color="<?php echo esc_attr( $overlay ) ?>"
                                 acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                 default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                 acp-show-rgb="no"
                                 acp-show-hsl="no"
                                 acp-palette-editable>
                            </div>
                            <input type="hidden"
                                   name="_treweler_bg_overlay"
                                   class="input-color"
                                   value="<?php echo esc_attr( $overlay ) ?>">
                            <input type="hidden" class="js-twer-colorpicker-custom-color" name="default_color" value="<?php echo esc_attr($custom_color); ?>">
                        </div>
                    </div>

                    <p style="font-size: 12px;"><?php esc_html_e('To load the map smoothly, use the preloader settings','treweler'); ?></p>

                    <hr>

                    <p>
                        <input type="hidden" name="_treweler_world_copy" value="">
                        <input type="checkbox" name="_treweler_world_copy" id="world_copy"
                               value="1" <?php checked( isset( $meta_data->world_copy ) ? $meta_data->world_copy : is_int( $post_id ) ); ?>>
                      <?php echo esc_html__( "Render world copies", 'treweler' ); ?>
                    </p>

                </div>
            </div>
        </div>
    </div>
</div>
