<?php
/**
 * Marker details meta box.
 *
 * @package Treweler/Admin
 */

if ( ! defined( 'ABSPATH' ) ) {
  exit;
}

$post_id = isset( $post->ID ) ? $post->ID : '';
$prefix = '_treweler_';
$meta_data = twer_get_data( $post_id );


$custom_color = get_option( 'treweler_mapbox_colorpicker_custom_color' );
$defaultColors = '#F44336|#EC407A|#E046C6|#B94AEF|#8559FF|#317DFC|#426D7E|#027F71|#008A43|#238C28|#4B7715|#756B11|#C06018|#9B5A45|#505050|#00B0F6|#00C5AF|#00BC5B|#18AF1F|#5DA900|#A19100|#FF7814|#FF5D28|#FFFFFF|#000000|';

function template_locks( $current_template, $field, $lock_meta ) { ?>
    <div class="twer-defaults js-twer-defaults <?php echo $current_template === 'none' || 'publish' !== get_post_status( $current_template ) ? 'd-none' : ''; ?>" style="right:0;">
      <?php
      if ( $field['type'] === 'group' || $field['type'] === 'group_simple' ) {
        foreach ( $field['value'] as $group_field ) {
          $lock_input = '<input type="hidden" name="%s" value="%s">';
          $lock_link = '<a href="#" class="twer-lock js-twer-lock-default %s" title="">%s</a>';

          $lock_name = strpos( $group_field['name'], '_treweler_' ) !== false ? $group_field['name'] . '_lock' : $field['name'] . '_' . $group_field['name'] . '_lock';
          $lock_meta_name = str_replace( '_treweler_', '', $lock_name );

          if ( $current_template === 'none' ) {
            $lock_value = 'open';
          } else {
            $lock_value = isset( $lock_meta->$lock_meta_name ) ? $lock_meta->$lock_meta_name : 'close';
          }

          $lock_input = sprintf( $lock_input, $lock_name, $lock_value );
          echo sprintf( $lock_link, 'twer-lock--' . $lock_value, $lock_input );
        }
      } else {
        $lock_input = '<input type="hidden" name="%s" value="%s">';
        $lock_link = '<a href="#" class="twer-lock js-twer-lock-default %s" title="">%s</a>';
        $lock_name = $field['name'] . '_lock';
        $lock_meta_name = str_replace( '_treweler_', '', $lock_name );

        if ( $current_template === 'none' ) {
          $lock_value = 'open';
        } else {
          $lock_value = isset( $lock_meta->$lock_meta_name ) ? $lock_meta->$lock_meta_name : 'close'; // $lock_meta->$lock_meta_name; //
        }

        $lock_input = sprintf( $lock_input, $lock_name, $lock_value );
        echo sprintf( $lock_link, 'twer-lock--' . $lock_value, $lock_input );
      } ?>
    </div>
  <?php
}

function template_meta_diff( $data ) {
  $new_data = [];
  foreach ( $data as $data_key => $data_item ) {
    switch ( $data_key ) {
      case 'custom_fields_font' :
        $new_data['custom_field_size'] = $data_item['size'];
        $new_data['custom_field_weight'] = $data_item['weight'];
        break;
      case 'label_marker_hide' :
        $new_data['marker_hide'] = $data_item;
        break;
      case 'label_weight' :
        $new_data['label_font_weight'] = $data_item;
        break;
      case 'label_size' :
        $new_data['label_font_size'] = $data_item;
        break;
      case 'label_color' :
        $new_data['label_font_color'] = $data_item;
        break;
      case 'label_enable' :
        $new_data['marker_enable_labels'] = $data_item;
        break;
      case 'popup_open_on' :
        $new_data['popup_open_group']['open_on'] = $data_item['action'];
        $new_data['popup_open_group']['open_default'] = $data_item['default'];
        break;
      case 'popup_heading' :
        $new_data['popup_heading'] = $data_item['text'];
        $new_data['popup_heading_size'] = $data_item['size'];
        $new_data['popup_heading_font_weight'] = $data_item['weight'];
        break;
      case 'popup_subheading' :
        $new_data['popup_subheading'] = $data_item['text'];
        $new_data['popup_subheading_size'] = $data_item['size'];
        $new_data['popup_subheading_font_weight'] = $data_item['weight'];
        break;
      case 'popup_description' :
        $new_data['popup_description'] = $data_item['text'];
        $new_data['popup_description_size'] = $data_item['size'];
        $new_data['popup_description_font_weight'] = $data_item['weight'];
        break;
      case 'popup_gallery' :
        $new_data['popup_image'] = $data_item;
        break;
      case 'popup_gallery_position' :
        $new_data['popup_image_position'] = $data_item;
        break;
      case 'popup_gallery_width' :
        $new_data['popup_image_width'] = $data_item;
        break;
      case 'point_color' :
        $new_data['marker_color'] = $data_item;
        break;
      case 'point_halo_color' :
        $new_data['marker_halo_color'] = $data_item;
        break;
      case 'dot_icon_show' :
        $new_data['picker_dot'] = $data_item;
        break;
      case 'dot_icon' :
        $new_data['dot_icon_color'] = $data_item['color'];
        $new_data['dot_icon_size'] = $data_item['size'];
        break;
      case 'dot' :
        $new_data['marker_dotcenter_color'] = $data_item['color'];
        $new_data['marker_size'] = $data_item['size'];
        break;
      case 'dot_border' :
        $new_data['marker_border_color'] = $data_item['color'];
        $new_data['marker_border_width'] = $data_item['size'];
        break;
      case 'dot_corner_radius' :
        $new_data['marker_corner_radius'] = $data_item['size'];
        $new_data['marker_corner_radius_units'] = $data_item['units'];
        break;
      case 'balloon_icon_show' :
        $new_data['picker'] = $data_item;
        break;
      case 'balloon_icon' :
        $new_data['balloon_icon_color'] = $data_item['color'];
        $new_data['balloon_icon_size'] = $data_item['size'];
        break;
      case 'balloon' :
        $new_data['marker_color_balloon'] = $data_item['color'];
        $new_data['marker_size_balloon'] = $data_item['size'];
        break;
      case 'balloon_border' :
        $new_data['marker_border_color_balloon'] = $data_item['color'];
        $new_data['marker_border_width_balloon'] = $data_item['size'];
        break;
      case 'balloon_dot' :
        $new_data['marker_dot_color'] = $data_item['color'];
        $new_data['marker_dot_size'] = $data_item['size'];
        break;
      case 'triangle_color' :
        $new_data['marker_color_triangle'] = $data_item;
        break;
      case 'triangle_width' :
        $new_data['marker_width_triangle'] = $data_item;
        break;
      case 'triangle_height' :
        $new_data['marker_height_triangle'] = $data_item;
        break;
      case 'custom_marker_img' :
        $new_data['thumbnail_id'] = $data_item;
        break;
      case 'custom_marker_position' :
        $new_data['marker_position'] = $data_item;
        break;
      case 'custom_marker_size' :
        $new_data['marker_img_size'] = $data_item;
        break;
      case 'custom_marker_cursor' :
        $new_data['marker_cursor'] = $data_item;
        break;
      case 'point_halo_opacity' :
        $new_data['marker_halo_opacity'] = $data_item;
        break;
      default :
        $new_data[ $data_key ] = $data_item;
        break;
    }
  }

  return (object) $new_data;
}

$template_data = [];
$current_template = isset( $meta_data->templates ) ? $meta_data->templates : 'none';
if ( 'none' !== $current_template && ! empty( $current_template ) ) {
  $template_data = template_meta_diff( twer_get_data( $current_template ) );
}


function template_apply( $fields, $meta_data, $template_data, $params = [] ) {
  $current_template = isset( $meta_data->templates ) ? $meta_data->templates : 'none';

  if ( 'none' !== $current_template ) {
    if ( 'publish' === get_post_status( $current_template ) ) {
      foreach ( $fields as &$field ) {
        if ( $field['type'] === 'group' || $field['type'] === 'group_simple' ) {
          $field['value'] = template_apply( $field['value'], $meta_data, $template_data, [ 'is_group' => true, 'group_name' => $field['name'] ] );
        } else {
          $group_name = isset( $params['group_name'] ) ? $params['group_name'] : '';
          $is_group = isset( $params['is_group'] ) ? $params['is_group'] : false;
          $format = strpos( $field['name'], '_treweler_' ) !== false && $is_group ? 'old' : 'new';

          if ( 'old' === $format && $is_group ) {
            $meta_key = str_replace( '_treweler_', '', $field['name'] );
            $template_value = isset($template_data->$meta_key) ? $template_data->$meta_key : '';
            $lock_name = $meta_key . '_lock';
            $lock_value = isset($meta_data->$lock_name) ? $meta_data->$lock_name : '';
          } else if ( 'new' === $format && $is_group ) {
            $meta_name = $is_group ? [ $group_name => $field['name'] ] : [ $field['name'] => '' ];
            $meta_key = str_replace( '_treweler_', '', array_keys( $meta_name )[0] );
            $meta_value = reset( $meta_name );

            $template_value = isset($template_data->$meta_key[ $meta_value ]) ? $template_data->$meta_key[ $meta_value ] : '';

            $lock_name = $meta_key . '_' . $meta_value . '_lock';
            $lock_value = isset($meta_data->$lock_name) ? $meta_data->$lock_name : 'close';
          } else {
            $meta_key = str_replace( '_treweler_', '', $field['name'] );
            $template_value = isset($template_data->$meta_key) ? $template_data->$meta_key : '';
            $lock_name = $meta_key . '_lock';
            $lock_value = isset($meta_data->$lock_name) ? $meta_data->$lock_name : 'close';
          }


          if ( is_array( $template_value ) && $field['type'] === 'checkbox' ) {
            $template_value = reset( $template_value );
          }

          $atts = [ 'data-default="' . $template_value . '"' ];

          if($field['type'] === 'image_custom') {
            $attachment = wp_get_attachment_image_src( $template_value, 'full' );
            $attachment = isset( $attachment[0] ) ? $attachment[0] : $template_value;
            $atts = [ 'data-default="' . $attachment . '"' ];
          }

          if ( 'close' === $lock_value ) {
            $atts[] = 'data-readonly="true"';
            switch ( $field['type'] ) {
              case 'checkbox' :
                $field['value'][0]['checked'] = $template_value;
                break;
              case 'select' :
                foreach ( $field['value'] as $select_key => $select_value ) {
                  if ( $select_value['value'] === $template_value ) {
                    $field['value'][ $select_key ]['selected'] = true;
                  } else {
                    $field['value'][ $select_key ]['selected'] = false;
                  }
                }
                break;
              case 'image_custom' :
                $attachment = wp_get_attachment_image_src( $template_value, 'full' );
                $field['value'] = isset( $attachment[0] ) ? $attachment[0] : $template_value;
                $atts = [ 'data-default="' . $field['value'] . '"', 'data-readonly="true"' ];
                break;
              case 'text' :
              case 'url' :
              case 'textarea' :
              case 'colorpicker_default' :
              case 'colorpicker' :
              case 'picker' :
              case 'gallery' :
                $field['value'] = $template_value;
                break;
            }
          }

          if ( ! empty( $atts ) ) {
            $field['data_template'] = $atts;
          }


        }
      }
    }
  }

  return $fields;
}

$fields_marker_styles = template_apply( [
  [
    'type'  => 'select',
    'name'  => $prefix . 'marker_style',
    'id'    => 'marker_style',
    'label' => esc_html__( 'Style', 'treweler' ),
    'value' => [
      [
        'label'    => esc_html__( 'Point', 'treweler' ),
        'selected' => in_array( 'default', isset( $meta_data->marker_style ) ? (array) $meta_data->marker_style : [ 'default' ] ),
        'value'    => 'default'
      ],
      [
        'label'    => esc_html__( 'Dot', 'treweler' ),
        'selected' => in_array( 'dot-default', isset( $meta_data->marker_style ) ? (array) $meta_data->marker_style : [] ),
        'value'    => 'dot-default'
      ],
      [
        'label'    => esc_html__( 'Balloon', 'treweler' ),
        'selected' => in_array( 'balloon-default', isset( $meta_data->marker_style ) ? (array) $meta_data->marker_style : [] ),
        'value'    => 'balloon-default'
      ],
      [
        'label'    => esc_html__( 'Triangle', 'treweler' ),
        'selected' => in_array( 'triangle-default', isset( $meta_data->marker_style ) ? (array) $meta_data->marker_style : [] ),
        'value'    => 'triangle-default'
      ],
      [
        'label'    => esc_html__( 'Custom Marker', 'treweler' ),
        'selected' => in_array( 'custom', isset( $meta_data->marker_style ) ? (array) $meta_data->marker_style : [] ),
        'value'    => 'custom'
      ],
    ]
  ],
  [
    'type'       => 'checkbox',
    'name'       => $prefix . 'picker',
    'label'      => esc_html__( 'Show Icon', 'treweler' ),
    'value'      => [
      [
        'label'   => '',
        'checked' => in_array( 'picker',
          isset( $meta_data->picker ) ? (array) $meta_data->picker : [] ),
        'value'   => 'picker'
      ]
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'balloon-default' ] ]
  ],
  [
    'type'       => 'picker',
    'name'       => $prefix . 'balloon_icon_picker',
    'label'      => esc_html__( 'Select Icon', 'treweler' ),
    'value'      => isset( $meta_data->balloon_icon_picker ) ? $meta_data->balloon_icon_picker : '',
    'toggle-row' => [ 'related' => 'treweler-picker', 'value' => true ]
  ],
  [
    'type'       => 'group_simple',
    'name'       => $prefix . 'balloon_icon_settings',
    'label'      => esc_html__( 'Icon', 'treweler' ),
    'value'      => [
      [
        'type'  => 'colorpicker',
        'name'  => $prefix . 'balloon_icon_color',
        'id'    => 'balloon_icon_color',
        'label' => esc_html__( 'Icon', 'treweler' ),
        'value' => isset( $meta_data->balloon_icon_color ) ? $meta_data->balloon_icon_color : '#ffffff',
      ],
      [
        'type'        => 'text',
        'name'        => $prefix . 'balloon_icon_size',
        'placeholder' => '15',
        'postfix'     => 'px',
        'size'        => 'small',
        'id'          => 'treweler-balloon-icon-size',
        'label'       => esc_html__( 'Icon Size', 'treweler' ),
        'value'       => isset( $meta_data->balloon_icon_size ) ? $meta_data->balloon_icon_size : ''
      ],
    ],
    'toggle-row' => [ 'related' => 'treweler-picker', 'value' => true ]
  ],
  [
    'type'       => 'checkbox',
    'name'       => $prefix . 'picker_dot',
    'label'      => esc_html__( 'Show Icon', 'treweler' ),
    'value'      => [
      [
        'label'   => '',
        'checked' => in_array( 'picker_dot',
          isset( $meta_data->picker_dot ) ? (array) $meta_data->picker_dot : [] ),
        'value'   => 'picker_dot'
      ]
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'dot-default' ] ]
  ],
  [
    'type'       => 'picker',
    'name'       => $prefix . 'dot_icon_picker',
    'label'      => esc_html__( 'Select Icon', 'treweler' ),
    'value'      => isset( $meta_data->dot_icon_picker ) ? $meta_data->dot_icon_picker : '',
    'toggle-row' => [ 'related' => 'treweler-picker-dot', 'value' => true ]
  ],
  [
    'type'       => 'group_simple',
    'name'       => $prefix . 'dot_icon_settings',
    'label'      => esc_html__( 'Icon', 'treweler' ),
    'value'      => [
      [
        'type'  => 'colorpicker',
        'name'  => $prefix . 'dot_icon_color',
        'id'    => 'dot_icon_color',
        'label' => esc_html__( 'Icon', 'treweler' ),
        'value' => isset( $meta_data->dot_icon_color ) ? $meta_data->dot_icon_color : '#ffffff',
      ],
      [
        'type'        => 'text',
        'name'        => $prefix . 'dot_icon_size',
        'placeholder' => '15',
        'postfix'     => 'px',
        'size'        => 'small',
        'id'          => 'treweler-dot-icon-size',
        'label'       => esc_html__( 'Icon Size', 'treweler' ),
        'value'       => isset( $meta_data->dot_icon_size ) ? $meta_data->dot_icon_size : ''
      ],
    ],
    'toggle-row' => [ 'related' => 'treweler-picker-dot', 'value' => true ]
  ],
  [
    'type'       => 'group_simple',
    'name'       => $prefix . 'balloon_marker_colors',
    'label'      => esc_html__( 'Marker', 'treweler' ),
    'value'      => [
      [
        'type'  => 'colorpicker',
        'name'  => $prefix . 'marker_color_balloon',
        'id'    => 'marker_color_balloon',
        'label' => esc_html__( 'Marker Color', 'treweler' ),
        'value' => isset( $meta_data->marker_color_balloon ) ? $meta_data->marker_color_balloon : '#4b7715',
      ],
      [
        'type'        => 'text',
        'name'        => $prefix . 'marker_size_balloon',
        'placeholder' => '18',
        'postfix'     => 'px',
        'size'        => 'small',
        'id'          => 'treweler-marker-size-balloon',
        'label'       => esc_html__( 'Marker Size', 'treweler' ),
        'value'       => isset( $meta_data->marker_size_balloon ) ? $meta_data->marker_size_balloon : '',
      ],
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'balloon-default' ] ]
  ],
  [
    'type'       => 'group_simple',
    'name'       => $prefix . 'balloon_marker_border_colors',
    'label'      => esc_html__( 'Border', 'treweler' ),
    'value'      => [
      [
        'type'  => 'colorpicker',
        'name'  => $prefix . 'marker_border_color_balloon',
        'id'    => 'marker_border_color_balloon',
        'label' => esc_html__( 'Border Color', 'treweler' ),
        'value' => isset( $meta_data->marker_border_color_balloon ) ? $meta_data->marker_border_color_balloon : '#4b7715',
      ],
      [
        'type'        => 'text',
        'name'        => $prefix . 'marker_border_width_balloon',
        'placeholder' => '4',
        'postfix'     => 'px',
        'size'        => 'small',
        'id'          => 'treweler-marker-border-width-balloon',
        'label'       => esc_html__( 'Border Width', 'treweler' ),
        'value'       => isset( $meta_data->marker_border_width_balloon ) ? $meta_data->marker_border_width_balloon : '',
      ],
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'balloon-default' ] ]
  ],
  [
    'type'       => 'group_simple',
    'name'       => $prefix . 'balloon_marker_dot_colors',
    'label'      => esc_html__( 'Dot', 'treweler' ),
    'value'      => [
      [
        'type'  => 'colorpicker',
        'name'  => $prefix . 'marker_dot_color',
        'id'    => 'marker_dot_color',
        'label' => esc_html__( 'Dot Color', 'treweler' ),
        'value' => isset( $meta_data->marker_dot_color ) ? $meta_data->marker_dot_color : '#ffffff',
      ],
      [
        'type'        => 'text',
        'name'        => $prefix . 'marker_dot_size',
        'placeholder' => '8',
        'postfix'     => 'px',
        'id'          => 'treweler-marker-dot-size',
        'size'        => 'small',
        'label'       => esc_html__( 'Dot size', 'treweler' ),
        'value'       => isset( $meta_data->marker_dot_size ) ? $meta_data->marker_dot_size : ''
      ],
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'balloon-default' ] ]
  ],
  [
    'type'       => 'colorpicker_default',
    'name'       => $prefix . 'marker_color',
    'id'         => 'markerColor',
    'label'      => esc_html__( 'Marker Color', 'treweler' ),
    'value'      => isset( $meta_data->marker_color ) ? $meta_data->marker_color : '#4b7715',
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'default' ], 'show' => true ]
  ],
  [
    'type'       => 'colorpicker',
    'name'       => $prefix . 'marker_halo_color',
    'id'         => 'marker_halo_color',
    'label'      => esc_html__( 'Halo Color', 'treweler' ),
    'value'      => isset( $meta_data->marker_halo_color ) ? $meta_data->marker_halo_color : '#ffffff',
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'default' ], 'show' => true ]
  ],
  [
    'type'        => 'text',
    'name'        => $prefix . 'marker_halo_opacity',
    'placeholder' => '0.5',
    'size'        => 'small',
    'label'       => esc_html__( 'Halo Opacity', 'treweler' ),
    'value'       => isset( $meta_data->marker_halo_opacity ) ? $meta_data->marker_halo_opacity : '',
    'help'        => esc_html__( 'The opacity property can take a value from 0.0 - 1.0. The lower value, the more transparent.',
      'treweler' ),
    'toggle-row'  => [ 'related' => 'marker_style', 'value' => [ 'default' ], 'show' => true ]
  ],
  [
    'type'       => 'group_simple',
    'name'       => $prefix . 'dot_marker_settings',
    'label'      => esc_html__( 'Marker', 'treweler' ),
    'value'      => [

      [
        'type'  => 'colorpicker',
        'name'  => $prefix . 'marker_dotcenter_color',
        'id'    => 'marker_dotcenter_color',
        'label' => esc_html__( 'Marker', 'treweler' ),
        'value' => isset( $meta_data->marker_dotcenter_color ) ? $meta_data->marker_dotcenter_color : '#4b7715',

      ],
      [
        'type'        => 'text',
        'name'        => $prefix . 'marker_size',
        'placeholder' => '12',
        'postfix'     => 'px',
        'size'        => 'small',
        'id'          => 'treweler-marker-size',
        'label'       => esc_html__( 'Marker Size', 'treweler' ),
        'value'       => isset( $meta_data->marker_size ) ? $meta_data->marker_size : '',

      ],
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'dot-default' ] ]
  ],
  [
    'type'       => 'group_simple',
    'name'       => $prefix . 'dot_border_settings',
    'label'      => esc_html__( 'Border', 'treweler' ),
    'value'      => [
      [
        'type'  => 'colorpicker',
        'name'  => $prefix . 'marker_border_color',
        'id'    => 'marker_border_color',
        'label' => esc_html__( 'Border Color', 'treweler' ),
        'value' => isset( $meta_data->marker_border_color ) ? $meta_data->marker_border_color : '#ffffff',
      ],
      [
        'type'        => 'text',
        'name'        => $prefix . 'marker_border_width',
        'placeholder' => '0',
        'postfix'     => 'px',
        'size'        => 'small',
        'id'          => 'treweler-marker-border-width',
        'label'       => esc_html__( 'Border Width', 'treweler' ),
        'value'       => isset( $meta_data->marker_border_width ) ? $meta_data->marker_border_width : '',
      ],
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'dot-default' ] ]
  ],
  [
    'type'       => 'group_simple',
    'name'       => $prefix . 'marker_corner_radius_group',
    'label'      => esc_html__( 'Corner Radius', 'treweler' ),
    'value'      => [
      [
        'type'        => 'text',
        'name'        => $prefix . 'marker_corner_radius',
        'placeholder' => '50',
        'size'        => 'small',

        'label' => esc_html__( 'Corner Radius', 'treweler' ),
        'value' => isset( $meta_data->marker_corner_radius ) ? $meta_data->marker_corner_radius : '',
      ],
      [
        'type' => 'select',
        'name' => $prefix . 'marker_corner_radius_units',

        'label' => esc_html__( 'Style', 'treweler' ),
        'value' => [
          [
            'label'    => esc_html__( '%', 'treweler' ),
            'selected' => in_array( '%', isset( $meta_data->marker_corner_radius_units ) ? (array) $meta_data->marker_corner_radius_units : [ '%' ] ),
            'value'    => '%'
          ],
          [
            'label'    => esc_html__( 'px', 'treweler' ),
            'selected' => in_array( 'px', isset( $meta_data->marker_corner_radius_units ) ? (array) $meta_data->marker_corner_radius_units : [] ),
            'value'    => 'px'
          ],
        ]
      ],
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'dot-default' ] ]
  ],
  [
    'type'       => 'colorpicker',
    'name'       => $prefix . 'marker_color_triangle',
    'id'         => 'marker_color_triangle',
    'label'      => esc_html__( 'Marker Color', 'treweler' ),
    'value'      => isset( $meta_data->marker_color_triangle ) ? $meta_data->marker_color_triangle : '#4b7715',
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'triangle-default' ] ]
  ],
  [
    'type'        => 'text',
    'name'        => $prefix . 'marker_width_triangle',
    'placeholder' => '12',
    'postfix'     => 'px',
    'size'        => 'small',
    'label'       => esc_html__( 'Marker Width', 'treweler' ),
    'value'       => isset( $meta_data->marker_width_triangle ) ? $meta_data->marker_width_triangle : '',
    'toggle-row'  => [ 'related' => 'marker_style', 'value' => [ 'triangle-default' ] ]
  ],
  [
    'type'        => 'text',
    'name'        => $prefix . 'marker_height_triangle',
    'placeholder' => '10',
    'postfix'     => 'px',
    'size'        => 'small',
    'label'       => esc_html__( 'Marker Height', 'treweler' ),
    'value'       => isset( $meta_data->marker_height_triangle ) ? $meta_data->marker_height_triangle : '',
    'toggle-row'  => [ 'related' => 'marker_style', 'value' => [ 'triangle-default' ] ]
  ],
  [
    'type'       => 'image_custom',
    'name'       => $prefix . 'thumbnail_id',
    'id'         => 'thumbnail_id',
    'label'      => esc_html__( 'Custom Marker', 'treweler' ),
    'value'      => isset( $meta_data->thumbnail_id ) ? $meta_data->thumbnail_id : '',
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'custom' ] ]
  ],
  [
    'type'       => 'select',
    'name'       => $prefix . 'marker_position',
    'id'         => 'marker_position',
    'label'      => esc_html__( 'Position', 'treweler' ),
    'value'      => [
      [
        'label'    => esc_html__( 'Center', 'treweler' ),
        'selected' => in_array( 'center', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [ 'center' ] ),
        'value'    => 'center'
      ],
      [
        'label'    => esc_html__( 'Top', 'treweler' ),
        'selected' => in_array( 'top', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [] ),
        'value'    => 'top'
      ],
      [
        'label'    => esc_html__( 'Bottom', 'treweler' ),
        'selected' => in_array( 'bottom', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [] ),
        'value'    => 'bottom'
      ],
      [
        'label'    => esc_html__( 'Left', 'treweler' ),
        'selected' => in_array( 'left', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [] ),
        'value'    => 'left'
      ],
      [
        'label'    => esc_html__( 'Right', 'treweler' ),
        'selected' => in_array( 'right', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [] ),
        'value'    => 'right'
      ],
      [
        'label'    => esc_html__( 'Top-left', 'treweler' ),
        'selected' => in_array( 'top-left', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [] ),
        'value'    => 'top-left'
      ],
      [
        'label'    => esc_html__( 'Top-right', 'treweler' ),
        'selected' => in_array( 'top-right', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [] ),
        'value'    => 'top-right'
      ],
      [
        'label'    => esc_html__( 'Bottom-left', 'treweler' ),
        'selected' => in_array( 'bottom-left', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [] ),
        'value'    => 'bottom-left'
      ],
      [
        'label'    => esc_html__( 'Bottom-right', 'treweler' ),
        'selected' => in_array( 'bottom-left', isset( $meta_data->marker_position ) ? (array) $meta_data->marker_position : [] ),
        'value'    => 'bottom-right'
      ],
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'custom' ] ]
  ],
  [
    'type'        => 'text',
    'name'        => $prefix . 'marker_img_size',
    'placeholder' => '42',
    'postfix'     => 'px',
    'size'        => 'small',
    'label'       => esc_html__( 'Marker Size', 'treweler' ),
    'value'       => isset( $meta_data->marker_img_size ) ? $meta_data->marker_img_size : '',
    'toggle-row'  => [ 'related' => 'marker_style', 'value' => [ 'custom' ] ]
  ],
  [
    'type'       => 'select',
    'name'       => $prefix . 'marker_cursor',
    'id'         => 'marker_cursor',
    'label'      => esc_html__( 'Cursor on Hover', 'treweler' ),
    'value'      => [
      [
        'label'    => esc_html__( 'Pointer', 'treweler' ),
        'selected' => in_array( 'pointer', isset( $meta_data->marker_cursor ) ? (array) $meta_data->marker_cursor : [ 'pointer' ] ),
        'value'    => 'pointer'
      ],
      [
        'label'    => esc_html__( 'Grab', 'treweler' ),
        'selected' => in_array( 'grab', isset( $meta_data->marker_cursor ) ? (array) $meta_data->marker_cursor : [] ),
        'value'    => 'grab'
      ],
    ],
    'toggle-row' => [ 'related' => 'marker_style', 'value' => [ 'custom' ] ]
  ],
], $meta_data, $template_data );

$fields_popup = template_apply( [
  [
    'type'  => 'checkbox',
    'name'  => $prefix . 'popup_show',
    'label' => esc_html__( 'Show popup', 'treweler' ),
    'value' => [
      [
        'label'   => '',
        'checked' => in_array( 'popup_show',
          isset( $meta_data->popup_show ) ? (array) $meta_data->popup_show : [] ),
        'value'   => 'popup_show'
      ]
    ]
  ],
  [
    'type'  => 'group_simple',
    'name'  => $prefix . 'popup_heading_settings',
    'label' => esc_html__( 'Heading', 'treweler' ),
    'value' => [
      [
        'type'  => 'text',
        'name'  => $prefix . 'popup_heading',
        'value' => isset( $meta_data->popup_heading ) ? $meta_data->popup_heading : ''
      ],
      [
        'type'        => 'text',
        'postfix'     => 'px',
        'size'        => 'small',
        'name'        => $prefix . 'popup_heading_size',
        'value'       => isset( $meta_data->popup_heading_size ) ? $meta_data->popup_heading_size : '',
        'placeholder' => '16'
      ],
      [
        'type'  => 'select',
        'name'  => $prefix . 'popup_heading_font_weight',
        'value' => [
          [
            'label'    => esc_html__( 'Thin 100', 'treweler' ),
            'selected' => in_array( '100',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [] ),
            'value'    => '100'
          ],
          [
            'label'    => esc_html__( 'Extra Light 200', 'treweler' ),
            'selected' => in_array( '200',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [] ),
            'value'    => '200'
          ],
          [
            'label'    => esc_html__( 'Light 300', 'treweler' ),
            'selected' => in_array( '300',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [] ),
            'value'    => '300'
          ],
          [
            'label'    => esc_html__( 'Regular 400', 'treweler' ),
            'selected' => in_array( '400',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [ '400' ] ),
            'value'    => '400'
          ],
          [
            'label'    => esc_html__( 'Medium 500', 'treweler' ),
            'selected' => in_array( '500',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [] ),
            'value'    => '500'
          ],
          [
            'label'    => esc_html__( 'Semi Bold 600', 'treweler' ),
            'selected' => in_array( '600',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [] ),
            'value'    => '600'
          ],
          [
            'label'    => esc_html__( 'Bold 700', 'treweler' ),
            'selected' => in_array( '700',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [ ] ),
            'value'    => '700'
          ],
          [
            'label'    => esc_html__( 'Extra Bold 800', 'treweler' ),
            'selected' => in_array( '800',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [] ),
            'value'    => '800'
          ],
          [
            'label'    => esc_html__( 'Black 900', 'treweler' ),
            'selected' => in_array( '900',
              isset( $meta_data->popup_heading_font_weight ) ? (array) $meta_data->popup_heading_font_weight : [] ),
            'value'    => '900'
          ],
        ]
      ],
    ]
  ],
  [
    'type'  => 'group_simple',
    'name'  => $prefix . 'popup_subheading_settings',
    'label' => esc_html__( 'Subheading', 'treweler' ),
    'value' => [
      [
        'type'  => 'text',
        'name'  => $prefix . 'popup_subheading',
        'value' => isset( $meta_data->popup_subheading ) ? $meta_data->popup_subheading : ''
      ],
      [
        'type'        => 'text',
        'postfix'     => 'px',
        'size'        => 'small',
        'name'        => $prefix . 'popup_subheading_size',
        'value'       => isset( $meta_data->popup_subheading_size ) ? $meta_data->popup_subheading_size : '',
        'placeholder' => '13'
      ],
      [
        'type'  => 'select',
        'name'  => $prefix . 'popup_subheading_font_weight',
        'value' => [
          [
            'label'    => esc_html__( 'Thin 100', 'treweler' ),
            'selected' => in_array( '100',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [] ),
            'value'    => '100'
          ],
          [
            'label'    => esc_html__( 'Extra Light 200', 'treweler' ),
            'selected' => in_array( '200',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [] ),
            'value'    => '200'
          ],
          [
            'label'    => esc_html__( 'Light 300', 'treweler' ),
            'selected' => in_array( '300',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [] ),
            'value'    => '300'
          ],
          [
            'label'    => esc_html__( 'Regular 400', 'treweler' ),
            'selected' => in_array( '400',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [ '400' ] ),
            'value'    => '400'
          ],
          [
            'label'    => esc_html__( 'Medium 500', 'treweler' ),
            'selected' => in_array( '500',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [] ),
            'value'    => '500'
          ],
          [
            'label'    => esc_html__( 'Semi Bold 600', 'treweler' ),
            'selected' => in_array( '600',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [] ),
            'value'    => '600'
          ],
          [
            'label'    => esc_html__( 'Bold 700', 'treweler' ),
            'selected' => in_array( '700',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [] ),
            'value'    => '700'
          ],
          [
            'label'    => esc_html__( 'Extra Bold 800', 'treweler' ),
            'selected' => in_array( '800',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [] ),
            'value'    => '800'
          ],
          [
            'label'    => esc_html__( 'Black 900', 'treweler' ),
            'selected' => in_array( '900',
              isset( $meta_data->popup_subheading_font_weight ) ? (array) $meta_data->popup_subheading_font_weight : [] ),
            'value'    => '900'
          ],
        ]
      ],
    ]
  ],
  [
    'type'  => 'group_simple',
    'name'  => $prefix . 'popup_description_settings',
    'label' => esc_html__( 'Description', 'treweler' ),
    'value' => [
      [
        'type'  => 'textarea',
        'name'  => $prefix . 'popup_description',
        'value' => isset( $meta_data->popup_description ) ? $meta_data->popup_description : ''
      ],
      [
        'type'        => 'text',
        'postfix'     => 'px',
        'size'        => 'small',
        'name'        => $prefix . 'popup_description_size',
        'value'       => isset( $meta_data->popup_description_size ) ? $meta_data->popup_description_size : '',
        'placeholder' => '13'
      ],
      [
        'type'  => 'select',
        'name'  => $prefix . 'popup_description_font_weight',
        'value' => [
          [
            'label'    => esc_html__( 'Thin 100', 'treweler' ),
            'selected' => in_array( '100',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [] ),
            'value'    => '100'
          ],
          [
            'label'    => esc_html__( 'Extra Light 200', 'treweler' ),
            'selected' => in_array( '200',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [] ),
            'value'    => '200'
          ],
          [
            'label'    => esc_html__( 'Light 300', 'treweler' ),
            'selected' => in_array( '300',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [] ),
            'value'    => '300'
          ],
          [
            'label'    => esc_html__( 'Regular 400', 'treweler' ),
            'selected' => in_array( '400',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [ '400' ] ),
            'value'    => '400'
          ],
          [
            'label'    => esc_html__( 'Medium 500', 'treweler' ),
            'selected' => in_array( '500',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [ '400' ] ),
            'value'    => '500'
          ],
          [
            'label'    => esc_html__( 'Semi Bold 600', 'treweler' ),
            'selected' => in_array( '600',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [] ),
            'value'    => '600'
          ],
          [
            'label'    => esc_html__( 'Bold 700', 'treweler' ),
            'selected' => in_array( '700',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [] ),
            'value'    => '700'
          ],
          [
            'label'    => esc_html__( 'Extra Bold 800', 'treweler' ),
            'selected' => in_array( '800',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [] ),
            'value'    => '800'
          ],
          [
            'label'    => esc_html__( 'Black 900', 'treweler' ),
            'selected' => in_array( '900',
              isset( $meta_data->popup_description_font_weight ) ? (array) $meta_data->popup_description_font_weight : [] ),
            'value'    => '900'
          ],
        ]
      ],
    ]
  ],
  [
    'type'  => 'gallery',
    'name'  => $prefix . 'popup_image',
    'id'    => 'treweler-popup-gallery',
    'label' => esc_html__( 'Images', 'treweler' ),
    'value' => isset( $meta_data->popup_image ) ? $meta_data->popup_image : ''
  ],
  [
    'type'  => 'checkbox',
    'name'  => $prefix . 'popup_gallery_show',
    'label' => esc_html__( 'Enable Image Gallery', 'treweler' ),
    'value' => [
      [
        'label'   => '',
        'checked' => in_array( 'popup_gallery_show', isset( $meta_data->popup_gallery_show ) ? (array) $meta_data->popup_gallery_show : [] ),
        'value'   => 'popup_gallery_show'
      ]
    ]
  ],
  [
    'type'  => 'select',
    'name'  => $prefix . 'popup_image_position',
    'label' => esc_html__( 'Image position', 'treweler' ),
    'value' => [
      [
        'label'    => esc_html__( 'Right', 'treweler' ),
        'selected' => in_array( 'right',
          isset( $meta_data->popup_image_position ) ? (array) $meta_data->popup_image_position : [ 'right' ] ),
        'value'    => 'right'
      ],
      [
        'label'    => esc_html__( 'Top', 'treweler' ),
        'selected' => in_array( 'top',
          isset( $meta_data->popup_image_position ) ? (array) $meta_data->popup_image_position : [] ),
        'value'    => 'top'
      ]
    ]
  ],
  [
    'type'        => 'text',
    'postfix'     => 'px',
    'size'        => 'small',
    'name'        => $prefix . 'popup_image_width',
    'label'       => esc_html__( 'Image width', 'treweler' ),
    'value'       => isset( $meta_data->popup_image_width ) ? $meta_data->popup_image_width : '',
    'placeholder' => '160'
  ],
  [
    'type'  => 'group',
    'name'  => $prefix . 'popup_button',
    'label' => esc_html__( 'Button', 'treweler' ),
    'value' => [
      [
        'type'  => 'text',
        'name'  => 'text',
        'label' => esc_html__( 'Text', 'treweler' ),
        'value' => isset( $meta_data->popup_button['text'] ) ? $meta_data->popup_button['text'] : ''
      ],
      [
        'type'  => 'url',
        'name'  => 'url',
        'label' => esc_html__( 'URL', 'treweler' ),
        'value' => isset( $meta_data->popup_button['url'] ) ? $meta_data->popup_button['url'] : ''
      ],
      [
        'type'  => 'colorpicker',
        'name'  => 'color',
        'label' => esc_html__( 'Color', 'treweler' ),
        'value' => isset( $meta_data->popup_button['color'] ) ? $meta_data->popup_button['color'] : '#4a7805'
      ],
      [
        'type'  => 'checkbox',
        'name'  => 'target',
        'label' => esc_html__( 'Open in new tab', 'treweler' ),
        'value' => [
          [
            'label'   => '',
            'checked' => in_array( 'target',
              isset( $meta_data->popup_button['target'] ) ? (array) $meta_data->popup_button['target'] : [] ),
            'value'   => 'target'
          ]
        ]
      ],
    ]
  ],
  [
    'type'  => 'select',
    'name'  => $prefix . 'popup_content_align',
    'label' => esc_html__( 'Content align', 'treweler' ),
    'value' => [
      [
        'label'    => esc_html__( 'Left', 'treweler' ),
        'selected' => in_array( 'left',
          isset( $meta_data->popup_content_align ) ? (array) $meta_data->popup_content_align : [ 'left' ] ),
        'value'    => 'left'
      ],
      [
        'label'    => esc_html__( 'Center', 'treweler' ),
        'selected' => in_array( 'center',
          isset( $meta_data->popup_content_align ) ? (array) $meta_data->popup_content_align : [] ),
        'value'    => 'center'
      ]
    ]
  ],
  [
    'type'  => 'group',
    'name'  => $prefix . 'popup_size',
    'label' => esc_html__( 'Min width and height', 'treweler' ),
    'value' => [
      [
        'type'    => 'text',
        'postfix' => 'px',
        'size'    => 'small',
        'name'    => 'height',
        'label'   => esc_html__( 'Height', 'treweler' ),
        'value'   => isset( $meta_data->popup_size['height'] ) ? $meta_data->popup_size['height'] : ''
      ],
      [
        'type'    => 'text',
        'postfix' => 'px',
        'size'    => 'small',
        'name'    => 'width',
        'label'   => esc_html__( 'Width', 'treweler' ),
        'value'   => isset( $meta_data->popup_size['width'] ) ? $meta_data->popup_size['width'] : ''
      ],
    ]
  ],
  [
    'type'        => 'text',
    'postfix'     => 'px',
    'size'        => 'small',
    'name'        => $prefix . 'popup_border_radius',
    'label'       => esc_html__( 'Corner Radius', 'treweler' ),
    'value'       => isset( $meta_data->popup_border_radius ) ? $meta_data->popup_border_radius : '',
    'placeholder' => '0'
  ],
  [
    'type'  => 'select',
    'name'  => $prefix . 'popup_style',
    'label' => esc_html__( 'Style', 'treweler' ),
    'value' => [
      [
        'label'    => esc_html__( 'Light', 'treweler' ),
        'selected' => in_array( 'light',
          isset( $meta_data->popup_style ) ? (array) $meta_data->popup_style : [ 'light' ] ),
        'value'    => 'light'
      ],
      [
        'label'    => esc_html__( 'Dark', 'treweler' ),
        'selected' => in_array( 'dark',
          isset( $meta_data->popup_style ) ? (array) $meta_data->popup_style : [] ),
        'value'    => 'dark'
      ]
    ]
  ],
  [
    'type'  => 'group',
    'name'  => $prefix . 'popup_open_group',
    'label' => esc_html__( 'Open popup on', 'treweler' ),
    'value' => [
      [
        'type'  => 'select',
        'name'  => 'open_on',
        'label' => esc_html__( 'Open popup on', 'treweler' ),
        'value' => [
          [
            'label'    => esc_html__( 'Hover', 'treweler' ),
            'selected' => in_array( 'hover',
              isset( $meta_data->popup_open_group['open_on'] ) ? (array) $meta_data->popup_open_group['open_on'] : [ 'hover' ] ),
            'value'    => 'hover'
          ],
          [
            'label'    => esc_html__( 'Click', 'treweler' ),
            'selected' => in_array( 'click',
              isset( $meta_data->popup_open_group['open_on'] ) ? (array) $meta_data->popup_open_group['open_on'] : [] ),
            'value'    => 'click'
          ],
          [
            'label'    => esc_html__( 'Always open', 'treweler' ),
            'selected' => in_array( 'always_open',
              isset( $meta_data->popup_open_group['open_on'] ) ? (array) $meta_data->popup_open_group['open_on'] : [] ),
            'value'    => 'always_open'
          ]
        ]
      ],
      [
        'type'  => 'checkbox',
        'name'  => 'open_default',
        'label' => esc_html__( 'Open by default', 'treweler' ),
        'value' => [
          [
            'label'   => '',
            'checked' => in_array( 'open_default',
              isset( $meta_data->popup_open_group['open_default'] ) ? (array) $meta_data->popup_open_group['open_default'] : [] ),
            'value'   => 'open_default'
          ]
        ]
      ],
    ]
  ],
], $meta_data, $template_data );

$fields_clusters = template_apply( [
  [
    'type'  => 'checkbox',
    'name'  => $prefix . 'marker_enable_clustering',
    'label' => esc_html__( 'Enable Clustering', 'treweler' ),
    'value' => [
      [
        'label'   => '',
        'checked' => in_array( 'marker_enable_clustering',
          isset( $meta_data->marker_enable_clustering ) ? (array) $meta_data->marker_enable_clustering : [ 'marker_enable_clustering' ] ),
        'value'   => 'marker_enable_clustering'
      ]
    ]
  ],
  [
    'type'  => 'checkbox',
    'name'  => $prefix . 'marker_enable_center_on_click',
    'label' => esc_html__( 'Center On Click', 'treweler' ),
    'value' => [
      [
        'label'   => '',
        'checked' => in_array( 'marker_enable_center_on_click',
          isset( $meta_data->marker_enable_center_on_click ) ? (array) $meta_data->marker_enable_center_on_click : [ 'marker_enable_center_on_click' ] ),
        'value'   => 'marker_enable_center_on_click'
      ]
    ]
  ]
], $meta_data, $template_data );

$fields_labels = template_apply( [
  [
    'type'  => 'checkbox',
    'name'  => $prefix . 'marker_enable_labels',
    'label' => esc_html__( 'Show Text Label', 'treweler' ),
    'value' => [
      [
        'label'   => '',
        'checked' => in_array( 'marker_enable_labels',
          isset( $meta_data->marker_enable_labels ) ? (array) $meta_data->marker_enable_labels : [] ),
        'value'   => 'marker_enable_labels'
      ]
    ]
  ],
  [
    'type'  => 'textarea',
    'name'  => $prefix . 'label_description',
    'label' => esc_html__( 'Label Text', 'treweler' ),
    'value' => isset( $meta_data->label_description ) ? $meta_data->label_description : ''
  ],
  [
    'row_class'    => 'twer-tr-toggle twer-row js-twer-row',
    'row_atts' => 'data-row-id="label_has_bg"',
    'type'  => 'checkbox',
    'name'  => $prefix . 'label_has_bg',
    'id' => 'treweler-label-has-bg',
    'label' => esc_html__( 'Show Background', 'treweler' ),
    'value' => [
      [
        'label'   => '',
        'checked' => in_array( 'label_has_bg',
          isset( $meta_data->label_has_bg ) ? (array) $meta_data->label_has_bg : ['label_has_bg'] ),
        'value'   => 'label_has_bg'
      ]
    ]
  ],









  [
    'row_class'    => 'twer-row js-twer-row twer-tr-toggle js-toggle-row',
    'row_atts' => 'data-related-id="treweler-label-has-bg" data-related-val="1" data-row-id="label_border_radius"',
    'type'        => 'text',
    'postfix'     => 'px',
    'size'        => 'small',
    'name'        => $prefix . 'label_border_radius',
    'label'       => esc_html__( 'Corner Radius', 'treweler' ),
    'value'       => isset( $meta_data->label_border_radius ) ? $meta_data->label_border_radius : '',
    'placeholder' => '0'
  ],
  [
    'row_class'    => 'twer-row js-twer-row twer-tr-toggle js-toggle-row',
    'row_atts' => 'data-related-id="treweler-label-has-bg" data-related-val="1" data-row-id="label_border_radius"',
    'type'  => 'group',
    'name'  => $prefix . 'label_padding',
    'label' => esc_html__( 'Text Padding', 'treweler' ),
    'value' => [

      [
        'type'        => 'text',
        'name'        => 'top',
        'postfix'     => 'px',
        'size'        => 'small',
        'placeholder' => '8',
        'label'       => esc_html__( 'Top', 'treweler' ),
        'value'       => isset( $meta_data->label_padding['top'] ) ? $meta_data->label_padding['top'] : ''
      ],
      [
        'type'        => 'text',
        'name'        => 'bottom',
        'postfix'     => 'px',
        'size'        => 'small',
        'placeholder' => '6',
        'label'       => esc_html__( 'Bottom', 'treweler' ),
        'value'       => isset( $meta_data->label_padding['bottom'] ) ? $meta_data->label_padding['bottom'] : ''
      ],
      [
        'type'        => 'text',
        'name'        => 'left',
        'postfix'     => 'px',
        'size'        => 'small',
        'placeholder' => '17',
        'label'       => esc_html__( 'Left', 'treweler' ),
        'value'       => isset( $meta_data->label_padding['left'] ) ? $meta_data->label_padding['left'] : ''
      ],
      [
        'type'        => 'text',
        'name'        => 'right',
        'postfix'     => 'px',
        'size'        => 'small',
        'placeholder' => '17',
        'label'       => esc_html__( 'Right', 'treweler' ),
        'value'       => isset( $meta_data->label_padding['right'] ) ? $meta_data->label_padding['right'] : ''
      ],

    ]
  ],


  [
    'type'  => 'select',
    'name'  => $prefix . 'label_position',
    'label' => esc_html__( 'Position', 'treweler' ),
    'value' => [
      [
        'label'    => esc_html__( 'Left', 'treweler' ),
        'selected' => in_array( 'left',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [ 'left' ] ),
        'value'    => 'left'
      ],
      [
        'label'    => esc_html__( 'Right', 'treweler' ),
        'selected' => in_array( 'right',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [] ),
        'value'    => 'right'
      ],
      [
        'label'    => esc_html__( 'Top', 'treweler' ),
        'selected' => in_array( 'top',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [] ),
        'value'    => 'top'
      ],
      [
        'label'    => esc_html__( 'Top Left', 'treweler' ),
        'selected' => in_array( 'top_left',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [] ),
        'value'    => 'top_left'
      ],
      [
        'label'    => esc_html__( 'Top Right', 'treweler' ),
        'selected' => in_array( 'top_right',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [] ),
        'value'    => 'top_right'
      ],
      [
        'label'    => esc_html__( 'Bottom', 'treweler' ),
        'selected' => in_array( 'bottom',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [] ),
        'value'    => 'bottom'
      ],
      [
        'label'    => esc_html__( 'Bottom Left', 'treweler' ),
        'selected' => in_array( 'bottom_left',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [] ),
        'value'    => 'bottom_left'
      ],
      [
        'label'    => esc_html__( 'Bottom Right', 'treweler' ),
        'selected' => in_array( 'bottom_right',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [] ),
        'value'    => 'bottom_right'
      ],
      [
        'label'    => esc_html__( 'Center', 'treweler' ),
        'selected' => in_array( 'center',
          isset( $meta_data->label_position ) ? (array) $meta_data->label_position : [] ),
        'value'    => 'center'
      ],
    ]
  ],
  [
    'type'  => 'colorpicker',
    'name'  => $prefix . 'label_font_color',
    'id'    => 'twer-map-label-font-color',
    'label' => esc_html__( 'Font Color', 'treweler' ),
    'value' => isset( $meta_data->label_font_color ) ? $meta_data->label_font_color : '#000000'
  ],
  [
    'type'        => 'text',
    'name'        => $prefix . 'label_font_size',
    'postfix'     => 'px',
    'size'        => 'small',
    'label'       => esc_html__( 'Font Size', 'treweler' ),
    'value'       => isset( $meta_data->label_font_size ) ? $meta_data->label_font_size : '',
    'placeholder' => '12'
  ],
  [
    'type'  => 'select',
    'name'  => $prefix . 'label_font_weight',
    'label' => esc_html__( 'Font Weight', 'treweler' ),
    'value' => [
      [
        'label'    => esc_html__( 'Thin 100', 'treweler' ),
        'selected' => in_array( '100',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : [] ),
        'value'    => '100'
      ],
      [
        'label'    => esc_html__( 'Extra Light 200', 'treweler' ),
        'selected' => in_array( '200',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : [] ),
        'value'    => '200'
      ],
      [
        'label'    => esc_html__( 'Light 300', 'treweler' ),
        'selected' => in_array( '300',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : [] ),
        'value'    => '300'
      ],
      [
        'label'    => esc_html__( 'Regular 400', 'treweler' ),
        'selected' => in_array( '400',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : ['400'] ),
        'value'    => '400'
      ],
      [
        'label'    => esc_html__( 'Medium 500', 'treweler' ),
        'selected' => in_array( '500',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : [] ),
        'value'    => '500'
      ],
      [
        'label'    => esc_html__( 'Semi Bold 600', 'treweler' ),
        'selected' => in_array( '600',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : [ ] ),
        'value'    => '600'
      ],
      [
        'label'    => esc_html__( 'Bold 700', 'treweler' ),
        'selected' => in_array( '700',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : [] ),
        'value'    => '700'
      ],
      [
        'label'    => esc_html__( 'Extra Bold 800', 'treweler' ),
        'selected' => in_array( '800',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : [] ),
        'value'    => '800'
      ],
      [
        'label'    => esc_html__( 'Black 900', 'treweler' ),
        'selected' => in_array( '900',
          isset( $meta_data->label_font_weight ) ? (array) $meta_data->label_font_weight : [] ),
        'value'    => '900'
      ],
    ]
  ],
  [
    'type'        => 'text',
    'name'        => $prefix . 'label_letter_spacing',
    'postfix'     => 'px',
    'size'        => 'small',
    'label'       => esc_html__( 'Letter Spacing', 'treweler' ),
    'value'       => isset( $meta_data->label_letter_spacing ) ? $meta_data->label_letter_spacing : '',
    'placeholder' => '0'
  ],
  [
    'type'        => 'text',
    'name'        => $prefix . 'label_line_height',
    'size'        => 'small',
    'label'       => esc_html__( 'Line Height', 'treweler' ),
    'value'       => isset( $meta_data->label_line_height ) ? $meta_data->label_line_height : '',
    'placeholder' => '1.3'
  ],
  [
    'type'        => 'text',
    'name'        => $prefix . 'label_margin',
    'postfix'     => 'px',
    'size'        => 'small',
    'label'       => esc_html__( 'Margin', 'treweler' ),
    'value'       => isset( $meta_data->label_margin ) ? $meta_data->label_margin : '',
    'placeholder' => '5'
  ],
  [
    'type'  => 'checkbox',
    'name'  => $prefix . 'marker_hide',
    'label' => esc_html__( 'Hide Marker', 'treweler' ),
    'value' => [
      [
        'label'   => '',
        'checked' => in_array( 'marker_hide',
          isset( $meta_data->marker_hide ) ? (array) $meta_data->marker_hide : [] ),
        'value'   => 'marker_hide'
      ]
    ]
  ],
], $meta_data, $template_data );

// Get all custom fields
$all_custom_fields = get_posts( [
  'post_status'    => 'publish',
  'post_type'      => 'twer-custom-fields',
  'numberposts'    => - 1,
  'posts_per_page' => - 1,
  'order'          => 'ASC',
] );

// Get saved custom fields
if ( 'none' !== $current_template && 'publish' === get_post_status( $current_template )) {
  $current_custom_fields_ids = isset( $template_data->custom_fields_list ) ? $template_data->custom_fields_list : '';
} else {
  $current_custom_fields_ids = isset( $meta_data->custom_fields_list ) ? $meta_data->custom_fields_list : '';
}

// Get all includes/saved custom fields and save it to array
$includes_custom_fields_posts = ! empty( $current_custom_fields_ids ) ? get_posts( [
  'post_status' => 'publish',
  'post_type'   => 'twer-custom-fields',
  'orderby'     => 'post__in',
  'include'     => $current_custom_fields_ids
] ) : [];

function fill_custom_fields( $includes_custom_fields_posts, $prefix, $meta_data, $hidden = false ) {
  $current_custom_fields = [];
  if ( ! empty( $includes_custom_fields_posts ) ) {
    foreach ( $includes_custom_fields_posts as $field_post ) {
      $field_post_ID = isset( $field_post->ID ) ? $field_post->ID : 0;
      $field_post_title = isset( $field_post->post_title ) ? $field_post->post_title : '';
      $meta = twer_get_data( $field_post_ID );

      $field_post_type = isset( $meta->custom_field_type ) ? $meta->custom_field_type : 'text';
      $field_post_key = isset( $meta->custom_field_key ) ? $meta->custom_field_key : 'field-1488228';
      //$field_post_show = isset($meta->custom_field_show) ? $meta->custom_field_show : '';


      $tr_class = ! $hidden ? 'js-ui-slider-item' : 'js-hidden-item d-none';
      $disabled = ! $hidden ? '' : 'disabled';
      switch ( $field_post_type ) {
        case 'separator' :
          $default = isset( $meta->{$field_post_key} ) ? $meta->{$field_post_key} : '';
          $current = isset( $meta_data->{$field_post_key} ) ? $meta_data->{$field_post_key} : '';
          $current_saved = $current;
          $lock_value = isset( $meta_data->{$field_post_key . '_lock'} ) ? $meta_data->{$field_post_key . '_lock'} : 'close';

          if ( ! $hidden && empty( $lock_value ) ) {
            $lock_value = 'open';
          }

          if ( ! $hidden && 'close' === $lock_value && $default !== $current ) {
            $current = $default;
          }

          $current_custom_fields[] = [
            'tr-class'    => $tr_class,
            'tr-id'       => $field_post_ID,
            'label'       => $field_post_title,
            'type'        => 'text',
            'postfix'     => 'px',
            'size'        => 'small-2',
            'placeholder' => '0',
            'disabled'    => $disabled,
            'readonly'    => $lock_value === 'open' ? '' : 'readonly',
            'lock_fields' => 1,
            'lock_name'   => $prefix . $field_post_key . '_lock',
            'lock_value'  => $lock_value,
            'lock_open'   => $lock_value === 'open',
            'data_atts'   => 'data-default="' . $default . '" data-current=""',
            'name'        => $prefix . $field_post_key,
            'value'       => $current,
          ];
          break;
        case 'text' :
          $default = isset( $meta->{$field_post_key} ) ? $meta->{$field_post_key} : '';
          $current = isset( $meta_data->{$field_post_key} ) ? $meta_data->{$field_post_key} : '';
          $current_saved = $current;
          $lock_value = isset( $meta_data->{$field_post_key . '_lock'} ) ? $meta_data->{$field_post_key . '_lock'} : 'close';

          if ( ! $hidden && empty( $lock_value ) ) {
            $lock_value = 'open';
          }


          if ( ! $hidden && 'close' === $lock_value && $default !== $current ) {
            $current = $default;
          }

          $current_custom_fields[] = [
            'tr-class'    => $tr_class,
            'tr-id'       => $field_post_ID,
            'label'       => $field_post_title,
            'type'        => $field_post_type,
            'size'        => 'small-1',
            'lock_fields' => 1,
            'lock_name'   => $prefix . $field_post_key . '_lock',
            'lock_value'  => $lock_value,
            'lock_open'   => $lock_value === 'open',
            'disabled'    => $disabled,
            'readonly'    => $lock_value === 'open' ? '' : 'readonly',
            'data_atts'   => 'data-default="' . $default . '" data-current=""',
            'name'        => $prefix . $field_post_key,
            'value'       => $current,
          ];
          break;
        case 'email' :
        case 'link' :
        case 'phone' :
          $default = isset( $meta->{$field_post_key} ) ? $meta->{$field_post_key} : [];

          $text_placeholder = esc_html__( 'URL', 'treweler' );
          $stype = '';
          if ( $field_post_type === 'email' ) {
            $stype = 'email';
            $text_placeholder = esc_html__( 'Email', 'treweler' );
          } elseif ( $field_post_type === 'phone' ) {
            $stype = 'tel';
            $text_placeholder = esc_html__( 'Phone Number', 'treweler' );
          } elseif ( $field_post_type === 'link' ) {
            $stype = 'url';
          }
          $key_default = $stype . '_label';


          $text_default = isset( $default[ $key_default ] ) ? $default[ $key_default ] : '';
          $url_default = isset( $default[ $stype ] ) ? $default[ $stype ] : '';
          $target_default = isset( $default['target'] ) ? $default['target'] : [];
          $target_default = is_array( $target_default ) ? reset( $target_default ) : $target_default;
          $lock_value = isset( $meta_data->{$field_post_key . '_lock'} ) ? $meta_data->{$field_post_key . '_lock'} : '';

          $lock_value_text = isset( $lock_value['text'] ) ? $lock_value['text'] : 'close';
          $lock_value_url = isset( $lock_value['url'] ) ? $lock_value['url'] : 'close';
          $lock_value_target = isset( $lock_value['target'] ) ? $lock_value['target'] : 'close';


          $text_current = isset( $meta_data->{$field_post_key}['text'] ) ? $meta_data->{$field_post_key}['text'] : '';
          $text_current_saved = $text_current;
          $url_current = isset( $meta_data->{$field_post_key}['url'] ) ? $meta_data->{$field_post_key}['url'] : '';
          $url_current_saved = $url_current;
          $target_current = in_array( 'target', isset( $meta_data->{$field_post_key}['target'] ) ? (array) $meta_data->{$field_post_key}['target'] : [] );
          $target_current_saved = $target_current;
          if ( ! $hidden && empty( $lock_value_text ) ) {
            $lock_value_text = 'open';
          }

          if ( ! $hidden && empty( $lock_value_url ) ) {
            $lock_value_url = 'open';
          }

          if ( ! $hidden && empty( $lock_value_target ) ) {
            $lock_value_target = 'open';
          }

          if ( ! $hidden && 'close' === $lock_value_text && $text_default !== $text_current ) {
            $text_current = $text_default;
          }
          if ( ! $hidden && 'close' === $lock_value_url && $url_default !== $url_current ) {
            $url_current = $url_default;
          }
          if ( ! $hidden && 'close' === $lock_value_target && $target_default !== $target_current ) {
            $target_current = $target_default;
          }

          $value = [
            [
              'type'        => 'text',
              'name'        => 'text',
              'label'       => '',
              'lock_fields' => 1,
              'disabled'    => $disabled,
              'lock_open'   => $lock_value_text === 'open',
              'lock_name'   => $prefix . $field_post_key . '_lock[text]',
              'lock_value'  => $lock_value_text,
              'readonly'    => $lock_value_text === 'open' ? '' : 'readonly',
              'placeholder' => esc_html__( 'Text', 'treweler' ),
              'data_atts'   => 'data-default="' . $text_default . '" data-current=""',
              'value'       => $text_current
            ],
            [
              'type'        => $stype,
              'name'        => 'url',
              'disabled'    => $disabled,
              'label'       => '',
              'lock_fields' => 1,
              'lock_open'   => $lock_value_url === 'open',
              'lock_name'   => $prefix . $field_post_key . '_lock[url]',
              'lock_value'  => $lock_value_url,
              'readonly'    => $lock_value_url === 'open' ? '' : 'readonly',
              'placeholder' => $text_placeholder,
              'data_atts'   => 'data-default="' . $url_default . '" data-current=""',
              'value'       => $url_current
            ],
          ];


          if ( $field_post_type === 'link' ) {
            $value[] = [
              'type'        => 'checkbox',
              'name'        => 'target',
              'place'       => 'inline',
              'disabled'    => $disabled,
              'lock_fields' => 1,
              'lock_open'   => $lock_value_target === 'open',
              'lock_name'   => $prefix . $field_post_key . '_lock[target]',
              'lock_value'  => $lock_value_target,
              'readonly'    => $lock_value_target === 'open' ? '' : 'readonly',
              'data_atts'   => 'data-default="' . $target_default . '" data-current=""',
              'label'       => esc_html__( 'Open in new tab', 'treweler' ),
              'value'       => [
                [
                  'label'   => '',
                  'checked' => $target_current,
                  'value'   => 'target'
                ]
              ]
            ];
          }

          $current_custom_fields[] = [
            'tr-class'    => $tr_class,
            'tr-id'       => $field_post_ID,
            'lock_fields' => count( $value ),

            'type'  => 'group',
            'name'  => $prefix . $field_post_key,
            'label' => $field_post_title,
            'value' => $value
          ];
          break;
      }
    }
  }

  return $current_custom_fields;
}

$fields_custom_list = template_apply( [
  [
    'tr-class' => 'd-none',
    'label'    => 'fields',
    'type'     => 'text',
    'subtype'  => 'hidden',
    'class'    => 'js-twer-custom-fields-list',
    'name'     => $prefix . 'custom_fields_list',
    'value'    => isset( $meta_data->custom_fields_list ) ? $meta_data->custom_fields_list : '',
  ],
  [
    'type'  => 'checkbox',
    'name'  => $prefix . 'custom_field_show',
    'label' => esc_html__( 'Show Custom Fields', 'treweler' ),
    'value' => [
      [
        'label'   => '',
        'checked' => in_array( 'custom_field_show', isset( $meta_data->custom_field_show ) ? (array) $meta_data->custom_field_show : [] ),
        'value'   => 'custom_field_show'
      ]
    ]
  ],
  [
    'type'  => 'group_simple',
    'name'  => $prefix . 'custom_field_settings',
    'label' => esc_html__( 'Font Style', 'treweler' ),
    'value' => [
      [
        'type'        => 'text',
        'postfix'     => 'px',
        'size'        => 'small',
        'name'        => $prefix . 'custom_field_size',
        'value'       => isset( $meta_data->custom_field_size ) ? $meta_data->custom_field_size : '',
        'placeholder' => '13'
      ],
      [
        'type'  => 'select',
        'name'  => $prefix . 'custom_field_weight',
        'value' => [
          [
            'label'    => esc_html__( 'Thin 100', 'treweler' ),
            'selected' => in_array( '100',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [] ),
            'value'    => '100'
          ],
          [
            'label'    => esc_html__( 'Extra Light 200', 'treweler' ),
            'selected' => in_array( '200',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [] ),
            'value'    => '200'
          ],
          [
            'label'    => esc_html__( 'Light 300', 'treweler' ),
            'selected' => in_array( '300',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [] ),
            'value'    => '300'
          ],
          [
            'label'    => esc_html__( 'Regular 400', 'treweler' ),
            'selected' => in_array( '400',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [ '400' ] ),
            'value'    => '400'
          ],
          [
            'label'    => esc_html__( 'Medium 500', 'treweler' ),
            'selected' => in_array( '500',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [ ] ),
            'value'    => '500'
          ],
          [
            'label'    => esc_html__( 'Semi Bold 600', 'treweler' ),
            'selected' => in_array( '600',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [] ),
            'value'    => '600'
          ],
          [
            'label'    => esc_html__( 'Bold 700', 'treweler' ),
            'selected' => in_array( '700',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [] ),
            'value'    => '700'
          ],
          [
            'label'    => esc_html__( 'Extra Bold 800', 'treweler' ),
            'selected' => in_array( '800',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [] ),
            'value'    => '800'
          ],
          [
            'label'    => esc_html__( 'Black 900', 'treweler' ),
            'selected' => in_array( '900',
              isset( $meta_data->custom_field_weight ) ? (array) $meta_data->custom_field_weight : [] ),
            'value'    => '900'
          ],
        ]
      ],
    ]
  ]
], $meta_data, $template_data );

$fields_custom = array_merge(
  $fields_custom_list,
  fill_custom_fields( $includes_custom_fields_posts, $prefix, $meta_data ),
  fill_custom_fields( $all_custom_fields, $prefix, $meta_data, true )
);


// Get all excluded/not saved custom fields and save it to array
$excluded_custom_fields_posts = get_posts( [
  'post_status'    => 'publish',
  'post_type'      => 'twer-custom-fields',
  'posts_per_page' => - 1,
  'numberposts'    => - 1,
  'exclude'        => $current_custom_fields_ids
] );


$select_fields = [
  [
    'label'    => __( 'Select a Field', 'treweler' ),
    'selected' => false,
    'default'  => true,
    'value'    => 'none'
  ]
];

foreach ( $excluded_custom_fields_posts as $excluded_custom_field_post ) {
  $id = isset( $excluded_custom_field_post->ID ) ? $excluded_custom_field_post->ID : 0;
  $label = isset( $excluded_custom_field_post->post_title ) ? $excluded_custom_field_post->post_title : '';
  $meta = twer_get_data( $id );
  $field_type = isset( $meta->custom_field_type ) ? $meta->custom_field_type : '';


  if ( empty( $label ) ) {
    $label = sprintf( __( 'Field: %d' ), $id );
  }
  if ( $id ) {
    $select_fields[] = [
      'label'    => $label,
      'selected' => false,
      'value'    => $id
    ];
  }
}

$cf_class = '';
if ( 'none' !== $current_template ) {
  $cf_class = 'd-none';
}

$fields_custom[] = [
  'type'     => 'group_simple',
  'tr-class' => $cf_class,
  'name'     => $prefix . 'custom_field_add',
  'label'    => esc_html__( 'Add fields', 'treweler' ),
  'value'    => [
    [
      'type'        => 'select',
      'class_value' => 'col-fixed--200',
      'name'        => $prefix . 'custom_fields_all',
      'value'       => $select_fields
    ],
    [
      'type'  => 'button',
      'class' => 'js-add-custom-field',
      'label' => __( 'Add Field', 'treweler' )
    ],
  ]
];


$cpt_templates = get_posts( [
  'post_status'    => 'publish',
  'post_type'      => 'twer-templates',
  'numberposts'    => - 1,
  'posts_per_page' => - 1,
  'order'          => 'ASC',
] );


$templates_list = [
  [
    'label'    => __( 'Custom Template', 'treweler' ),
    'selected' => in_array( 'none', isset( $meta_data->templates ) ? (array) $meta_data->templates : [] ),
    'value'    => 'none'
  ]
];
if ( ! empty( $cpt_templates ) ) {
  foreach ( $cpt_templates as $template ) {
    $template_id = isset( $template->ID ) ? $template->ID : 0;
    $template_label = isset( $template->post_title ) ? $template->post_title : esc_html__( 'Template', 'treweler' );
    $template_value = in_array( $template_id, isset( $meta_data->templates ) ? (array) $meta_data->templates : [] );

    $templates_list[] = [
      'label'    => $template_label,
      'selected' => $template_value,
      'value'    => $template_id
    ];
  }
} else {

  $templates_list = [
    [
      'label'    => __( 'Templates Not Found', 'treweler' ),
      'selected' => 'none',
      'value'    => 'none'
    ]
  ];
}

$templates = [
  [
    'type'        => 'select',
    'class_value' => 'col-fixed--200',
    'label'       => esc_html__( 'Select a Template', 'treweler' ),
    'name'        => $prefix . 'templates',
    'id'          => 'js-twer-templates',
    'value'       => $templates_list
  ],
]
?>

<div class="twer-root">
    <div class="twer-settings">
        <div class="twer-settings__body">
            <div class="container-fluid p-0">
                <div class="row">
                    <div class="col-md-3 col-lg-3 col-xl-2 pr-md-0">
                        <nav class="twer-tabs">
                            <div class="nav nav-tabs" id="twer-nav-tab" role="tablist">
                                <a class="nav-item nav-link" id="twer-nav-clusters-tab" data-toggle="tab"
                                   href="#twer-nav-clusters" role="tab" aria-controls="twer-nav-clusters"
                                   aria-selected="false"><?php echo esc_html__( 'General', 'treweler' ); ?></a>
                                <a class="nav-item nav-link active" id="twer-nav-marker-styles-tab" data-toggle="tab"
                                   href="#twer-nav-marker-styles" role="tab" aria-controls="twer-nav-marker-styles"
                                   aria-selected="true"><?php echo esc_html__( 'Marker Styles', 'treweler' ); ?></a>
                                <a class="nav-item nav-link" id="twer-nav-popup-tab" data-toggle="tab"
                                   href="#twer-nav-popup" role="tab" aria-controls="twer-nav-popup"
                                   aria-selected="true"><?php echo esc_html__( 'Popup', 'treweler' ); ?></a>

                                <a class="nav-item nav-link" id="twer-nav-labels-tab" data-toggle="tab"
                                   href="#twer-nav-labels" role="tab" aria-controls="twer-nav-labels"
                                   aria-selected="false"><?php echo esc_html__( 'Text Label', 'treweler' ); ?></a>
                              <?php if ( ! empty( $all_custom_fields ) ) { ?>
                                  <a class="nav-item nav-link" id="twer-nav-custom-fields-tab" data-toggle="tab"
                                     href="#twer-nav-custom-fields" role="tab" aria-controls="twer-nav-custom-fields"
                                     aria-selected="false"><?php echo esc_html__( 'Custom Fields', 'treweler' ); ?></a>
                              <?php } ?>
                                <a class="nav-item nav-link" id="twer-nav-template-tab" data-toggle="tab"
                                   href="#twer-nav-template" role="tab" aria-controls="twer-nav-template"
                                   aria-selected="false"><?php echo esc_html__( 'Template', 'treweler' ); ?></a>
                            </div>
                        </nav>
                    </div>
                    <div class="col-md-9 col-lg-9 col-xl-10 pl-md-0">
                        <div class="tab-content" id="twer-Nav-tabContent">

                            <div class="tab-pane fade show active" id="twer-nav-marker-styles" role="tabpanel"
                                 aria-labelledby="twer-nav-popup-tab">
                                <div class="table-responsive">
                                    <table class="table twer-table twer-table--cells-2">
                                      <?php foreach (
                                        $fields_marker_styles

                                        as $field
                                      ) {
                                        if ( isset( $field['id'] ) ) {
                                          $element_id = $field['id'];
                                        } else {
                                          $element_id = trim( str_replace( '_', '-', $field['name'] ), '-' );
                                        }


                                        $tr_class = [ 'twer-tr-toggle' ];
                                        $tr_atts = [];

                                        if ( isset( $field['toggle_row'] ) ) {
                                          $tr_class[] = 'js-twer-tr-toggle';


                                          if ( isset( $field['toggle_row']['related_id'] ) ) {
                                            $tr_atts[] = 'id="' . $field['toggle_row']['related_id'] . '-toggle"';
                                          }

                                          if ( isset( $field['toggle_row']['trigger'] ) ) {
                                            $tr_atts[] = 'data-trigger="' . $field['toggle_row']['trigger'] . '"';
                                          }


                                        }

                                        if ( ! empty( $field['toggle-row'] ) ) {
                                          if ( ! empty( $field['toggle-row']['show'] ) ) {
                                            $tr_class[] = 'js-toggle-row';
                                          } else {
                                            $tr_class[] = 'js-toggle-row  d-none';
                                          }
                                          $tr_atts[] = 'data-related-id="' . esc_attr( $field['toggle-row']['related'] ) . '"';
                                          $att_value = $field['toggle-row']['value'];
                                          if ( is_array( $att_value ) ) {
                                            $att_value = implode( ',', $att_value );
                                          } else {
                                            $att_value = (string) $att_value;
                                          }
                                          $tr_atts[] = 'data-related-val="' . esc_attr( $att_value ) . '"';
                                        }
                                        ?>
                                          <tr class="<?php echo esc_attr( implode( ' ',
                                            $tr_class ) ); ?>" <?php echo implode( ' ', $tr_atts ); ?>>
                                              <th class="th-<?php echo esc_attr( $element_id ); ?>">
                                                  <label for="<?php echo esc_attr( $element_id ) ?>"><?php echo esc_html( $field['label'] ); ?></label>
                                              </th>
                                              <td>
                                                <?php
                                                $data_template = isset( $field['data_template'] ) ? implode( ' ', $field['data_template'] ) : '';
                                                ?>
                                                  <div class="twer-wrap-fields">
                                                    <?php template_locks( $current_template, $field, $meta_data ); ?>

                                                    <?php if ( 'select' === $field['type'] ) { ?>
                                                        <div class="twer-form-group twer-form-group--select">
                                                            <select name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                    class="large-select"
                                                              <?php echo $data_template; ?>
                                                                    id="<?php echo esc_attr( $element_id ); ?>">
                                                              <?php foreach ( $field['value'] as $data ) { ?>
                                                                  <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                              <?php } ?>
                                                            </select>
                                                        </div>
                                                    <?php } else if ( 'picker' === $field['type'] ) { ?>
                                                        <input type="text" <?php echo $data_template; ?> name="<?php echo esc_attr( $field['name'] ); ?>" id="<?php echo esc_attr( $element_id ); ?>" value="<?php echo esc_attr( $field['value'] ) ?>">
                                                    <?php } elseif ( 'checkbox' === $field['type'] ) { ?>
                                                        <input type="hidden"
                                                               name="<?php echo esc_attr( $field['name'] ); ?>"
                                                               value="">
                                                      <?php foreach ( $field['value'] as $data ) { ?>
                                                            <label for="<?php echo esc_attr( $element_id ) ?>"
                                                                   class="twer-switcher"
                                                              <?php echo $data_template; ?>
                                                            >
                                                                <input type="checkbox"

                                                                       name="<?php echo esc_attr( $field['name'] ); ?>[]"
                                                                       id="<?php echo esc_attr( $element_id ); ?>"
                                                                       value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                <div class="twer-switcher__slider"></div>
                                                            </label>
                                                      <?php } ?>
                                                    <?php } elseif ( 'colorpicker' === $field['type'] ) { ?>
                                                        <div class="js-twer-color-picker-wrap twer-color-picker-wrap" <?php echo $data_template; ?>>
                                                            <div class="map-text-color js-twer-color-picker">
                                                                                    <span class="color-holder"
                                                                                          style="background-color:<?php echo esc_attr( $field['value'] ) ?>;"></span>
                                                                <input type="button"
                                                                       class="text-color-picker-btn"
                                                                       value="<?php echo esc_attr__( 'Select Color',
                                                                         'treweler' ); ?>">
                                                            </div>
                                                            <!-- .color-picker-text-descr -->
                                                            <div class="js-twer-color-picker-palette twer-color-picker-palette"
                                                                 acp-color="<?php echo esc_attr( $field['value'] ) ?>"
                                                                 acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                 default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                 acp-show-rgb="no"
                                                                 acp-show-hsl="no"
                                                                 acp-palette-editable>
                                                            </div>
                                                            <input type="hidden"
                                                                   name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                   class="input-color input-color-field"

                                                                   id="<?php echo esc_attr( $field['id'] ); ?>"
                                                                   value="<?php echo esc_attr( $field['value'] ) ?>">
                                                        </div>
                                                    <?php } elseif ( 'colorpicker_default' === $field['type'] ) { ?>
                                                        <div class="twer-color-picker-wrap" <?php echo $data_template; ?>>

                                                            <div class="clr-picker" style="margin: 0">
                                                                <span class="color-holder" style="background-color:<?php echo esc_attr( $field['value'] ) ?>;"></span>
                                                                <input type="button" id="color-picker-btn" value="<?php echo esc_attr__( 'Select Color', 'treweler' ); ?>">
                                                            </div>
                                                            <div class="twer-color-picker-palette color-picker"
                                                                 acp-color="<?php echo esc_attr( $field['value'] ) ?>"
                                                                 acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                 default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                 acp-show-rgb="no"
                                                                 acp-show-hsl="no"
                                                                 acp-palette-editable>
                                                            </div>

                                                            <input type="hidden" name="addCustomColor" id="addCustomColor" value="<?php echo esc_attr( $custom_color ); ?>">
                                                            <input class="input-color-field" type="hidden" name="<?php echo esc_attr( $field['name'] ); ?>" id="markerColor" value="<?php echo esc_attr( $field['value'] ) ?>">


                                                        </div>

                                                    <?php } elseif ( 'text' === $field['type'] || 'url' === $field['type'] ) {

                                                      $field_class = [ 'twer-form-group twer-form-group--text' ];
                                                      $field_placeholder = '';
                                                      if ( isset( $field['size'] ) ) {
                                                        $field_class[] = 'twer-form-group--' . $field['size'];
                                                      }

                                                      if ( isset( $field['placeholder'] ) ) {
                                                        $field_placeholder = $field['placeholder'];
                                                      }
                                                      if ( isset( $field['postfix'] ) ) {
                                                        $field_class[] = 'twer-form-group--append';
                                                      }

                                                      if ( ! empty( $field['help'] ) ) {
                                                        $field_class[] = 'twer-help-input';
                                                      }
                                                      ?>

                                                        <div class="<?php echo esc_attr( implode( ' ', $field_class ) ); ?>">
                                                            <input type="<?php echo esc_attr( $field['type'] ); ?>"
                                                                   id="<?php echo esc_attr( $element_id ); ?>"
                                                                   name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                   class="large-text"
                                                              <?php echo $data_template; ?>
                                                                   value="<?php echo esc_attr( $field['value'] ) ?>"
                                                                   placeholder="<?php echo esc_attr( $field_placeholder ); ?>">
                                                          <?php if ( isset( $field['postfix'] ) ) { ?>
                                                              <div class="twer-form-group-append">
                                                                  <span class="twer-form-group-append__text"><?php echo esc_html( $field['postfix'] ); ?></span>
                                                              </div>
                                                          <?php } ?>


                                                          <?php if ( ! empty( $field['help'] ) ) { ?>
                                                              <a href="#" class="twer-help-tooltip"
                                                                 data-toggle="tooltip"
                                                                 title="<?php echo esc_attr( $field['help'] ); ?>"><span
                                                                          class="dashicons dashicons-editor-help"></span></a>
                                                          <?php } ?>
                                                        </div>
                                                    <?php } elseif ( 'textarea' === $field['type'] ) { ?>
                                                        <div class="twer-form-group twer-form-group--text">
                                                            <textarea class="large-text"
                                                                      name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                      id="<?php echo esc_attr( $element_id ); ?>"
                                                                      cols="30"
                                                                      <?php echo $data_template; ?>
                                                                      rows="6"><?php echo esc_attr( $field['value'] ) ?></textarea>
                                                        </div>
                                                    <?php } elseif ( 'image_custom' === $field['type'] ) { ?>
                                                        <div class="twer-attach js-twer-attach-wrap-custom" <?php echo $data_template; ?>>

                                                            <div class="twer-attach__thumb js-twer-attach-thumb-custom">
                                                              <?php if ( $field['value'] ) { ?>
                                                                  <img src="<?php echo esc_url( $field['value'] ); ?>"
                                                                       alt="">
                                                              <?php } ?>
                                                                <button type="button"

                                                                        style="<?php echo ! empty( $field['value'] ) ? 'display:none;' : 'display:block'; ?>"
                                                                        class="twer-attach__add-media js-twer-attach-add-custom"><?php echo esc_html__( 'Select File',
                                                                    'treweler' ); ?></button>

                                                                <input type="hidden"

                                                                       id="<?php echo esc_attr( $field['id'] ); ?>"
                                                                       name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                       value="<?php echo esc_attr( $field['value'] ) ?>">
                                                            </div>

                                                            <div class="twer-attach__actions js-twer-attach-actions-custom"
                                                                 style="<?php echo ! empty( $field['value'] ) ? 'display:block;' : 'display:none'; ?>">
                                                                <button type="button"
                                                                        class="button js-twer-attach-remove-custom"><?php echo esc_html__( 'Remove',
                                                                    'treweler' ); ?></button>
                                                                <button type="button"
                                                                        class="button js-twer-attach-add-custom"><?php echo esc_html__( 'Change file',
                                                                    'treweler' ); ?></button>
                                                            </div>
                                                        </div>
                                                    <?php } elseif ( 'image' === $field['type'] ) { ?>
                                                        <div class="twer-attach js-twer-attach-wrap">

                                                            <div class="twer-attach__thumb js-twer-attach-thumb">
                                                              <?php if ( $field['value'] ) { ?>
                                                                  <img src="<?php echo esc_url( $field['value'] ); ?>"
                                                                       alt="">
                                                              <?php } ?>
                                                                <button type="button"
                                                                        id="<?php echo esc_attr( $element_id ); ?>"
                                                                        style="<?php echo ! empty( $field['value'] ) ? 'display:none;' : 'display:block'; ?>"
                                                                        class="twer-attach__add-media js-twer-attach-add"><?php echo esc_html__( 'Select Image',
                                                                    'treweler' ); ?></button>

                                                                <input type="hidden"
                                                                  <?php echo $data_template; ?>
                                                                       name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                       value="<?php echo esc_attr( $field['value'] ) ?>">
                                                            </div>

                                                            <div class="twer-attach__actions js-twer-attach-actions"
                                                                 style="<?php echo ! empty( $field['value'] ) ? 'display:block;' : 'display:none'; ?>">
                                                                <button type="button"
                                                                        class="button js-twer-attach-remove"><?php echo esc_html__( 'Remove',
                                                                    'treweler' ); ?></button>
                                                                <button type="button"
                                                                        class="button js-twer-attach-add"><?php echo esc_html__( 'Change image',
                                                                    'treweler' ); ?></button>
                                                            </div>
                                                        </div>
                                                    <?php } elseif ( 'group' === $field['type'] ) { ?>
                                                        <div class="twer-group-elements">
                                                            <div class="row">
                                                              <?php foreach ( $field['value'] as $field_group ) {

                                                                $element_id_group = trim( str_replace( '_', '-',
                                                                  $field['name'] . '_' . $field_group['name'] ),
                                                                  '-' );
                                                                $field_group['name'] = $field['name'] . '[' . $field_group['name'] . ']';

                                                                $field_class = [];
                                                                if ( isset( $field_group['postfix'] ) ) {
                                                                  $field_class[] = 'twer-form-group--append';
                                                                }

                                                                $data_template = isset( $field_group['data_template'] ) ? implode( ' ', $field_group['data_template'] ) : '';

                                                                ?>
                                                                  <div class="<?php echo 'colorpicker' === $field_group['type'] ? 'col-simple' : 'col-fixed' ?>">
                                                                      <label for="<?php echo esc_attr( $element_id_group ); ?>"><?php echo esc_attr( $field_group['label'] ); ?></label>
                                                                    <?php if ( 'text' === $field_group['type'] || 'url' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--text <?php echo esc_attr( implode( ' ', $field_class ) ); ?>">
                                                                            <input type="<?php echo esc_attr( $field_group['type'] ); ?>"
                                                                                   id="<?php echo esc_attr( $element_id_group ); ?>"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="large-text"
                                                                              <?php echo $data_template; ?>
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>">
                                                                          <?php if ( isset( $field_group['postfix'] ) ) { ?>
                                                                              <div class="twer-form-group-append">
                                                                                  <span class="twer-form-group-append__text"><?php echo esc_html( $field_group['postfix'] ); ?></span>
                                                                              </div>
                                                                          <?php } ?>
                                                                        </div>


                                                                    <?php } elseif ( 'select' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--select">
                                                                            <select name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                    class="large-select"
                                                                              <?php echo $data_template; ?>
                                                                                    id="<?php echo esc_attr( $element_id_group ); ?>">
                                                                              <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                                  <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                              <?php } ?>
                                                                            </select>
                                                                        </div>


                                                                    <?php } elseif ( 'colorpicker' === $field_group['type'] ) { ?>
                                                                        <div class="js-twer-color-picker-wrap twer-color-picker-wrap" <?php echo $data_template; ?>>
                                                                            <div class="map-text-color js-twer-color-picker">
                                                                                    <span class="color-holder"
                                                                                          style="background-color:<?php echo esc_attr( $field_group['value'] ) ?>;"></span>
                                                                                <input type="button"
                                                                                       class="text-color-picker-btn"
                                                                                       value="<?php echo esc_attr__( 'Select Color',
                                                                                         'treweler' ); ?>">
                                                                            </div>
                                                                            <!-- .color-picker-text-descr -->
                                                                            <div class="js-twer-color-picker-palette twer-color-picker-palette"
                                                                                 acp-color="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                 acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                                 default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                                 acp-show-rgb="no"
                                                                                 acp-show-hsl="no"
                                                                                 acp-palette-editable>
                                                                            </div>
                                                                            <input type="hidden"

                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="input-color input-color-field"
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>">
                                                                        </div>
                                                                    <?php } elseif ( 'checkbox' === $field_group['type'] ) { ?>
                                                                        <input type="hidden"
                                                                               name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                               value="">
                                                                      <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                            <label for="<?php echo esc_attr( $element_id_group ) ?>"
                                                                                   class="twer-switcher"
                                                                              <?php echo $data_template; ?>
                                                                            >
                                                                                <input type="checkbox"

                                                                                       name="<?php echo esc_attr( $field_group['name'] ); ?>[]"
                                                                                       id="<?php echo esc_attr( $element_id_group ); ?>"
                                                                                       value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                                <div class="twer-switcher__slider"></div>
                                                                            </label>
                                                                      <?php } ?>
                                                                    <?php } ?>
                                                                  </div>
                                                              <?php } ?>
                                                            </div>
                                                        </div>
                                                    <?php } elseif ( 'group_simple' === $field['type'] ) { ?>
                                                        <div class="twer-group-elements">
                                                            <div class="row">
                                                              <?php
                                                              $simple_counter = 0;
                                                              foreach ( $field['value'] as $field_group ) {
                                                                $simple_counter ++;
                                                                $class_simple = '';
                                                                switch ( $simple_counter ) {
                                                                  case '1' :
                                                                    // $class_simple = 'col-fixed--260';
                                                                    break;
                                                                  case '2' :
                                                                    $class_simple = 'col-fixed--130';
                                                                    break;
                                                                  case '3' :
                                                                    $class_simple = 'col-fixed--200';
                                                                    break;
                                                                }

                                                                $fgi = isset( $field_group['id'] ) ? $field_group['id'] : '';
                                                                if ( 'marker_corner_radius' === $fgi ) {
                                                                  $class_simple = 'col-fixed--150';
                                                                }

                                                                $data_template = isset( $field_group['data_template'] ) ? implode( ' ', $field_group['data_template'] ) : '';
                                                                ?>
                                                                  <div style="margin-bottom: 0" class="<?php echo 'colorpicker' === $field_group['type'] ? 'col-simple' : 'col-fixed ' . $class_simple ?>">
                                                                    <?php if ( 'text' === $field_group['type'] || 'url' === $field_group['type'] ) {

                                                                      $field_group_class = [ 'twer-form-group twer-form-group--text' ];
                                                                      $field_group_placeholder = '';
                                                                      if ( isset( $field_group['size'] ) ) {
                                                                        $field_group_class[] = 'twer-form-group--' . $field_group['size'];
                                                                      }

                                                                      if ( isset( $field_group['placeholder'] ) ) {
                                                                        $field_group_placeholder = $field_group['placeholder'];
                                                                      }
                                                                      if ( isset( $field_group['postfix'] ) ) {
                                                                        $field_group_class[] = 'twer-form-group--append';
                                                                      }

                                                                      $isset_id = isset( $field_group['id'] ) ? $field_group['id'] : '';

                                                                      if ( $isset_id ) {
                                                                        $element_id = $isset_id;
                                                                      }

                                                                      ?>
                                                                        <div class="<?php echo esc_attr( implode( ' ', $field_group_class ) ); ?>">
                                                                            <input type="<?php echo esc_attr( $field_group['type'] ); ?>"
                                                                                   id="<?php echo esc_attr( $element_id ); ?>"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="large-text"
                                                                              <?php echo $data_template; ?>
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                   placeholder="<?php echo esc_attr( $field_group_placeholder ); ?>">
                                                                          <?php if ( isset( $field_group['postfix'] ) ) { ?>
                                                                              <div class="twer-form-group-append">
                                                                                  <span class="twer-form-group-append__text"><?php echo esc_html( $field_group['postfix'] ); ?></span>
                                                                              </div>
                                                                          <?php } ?>
                                                                        </div>
                                                                    <?php } elseif ( 'select' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--select">
                                                                            <select name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                    class="large-select"
                                                                              <?php echo $data_template; ?>
                                                                                    id="<?php echo esc_attr( $element_id ); ?>-select">
                                                                              <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                                  <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                              <?php } ?>
                                                                            </select>
                                                                        </div>
                                                                    <?php } elseif ( 'colorpicker' === $field_group['type'] ) {
                                                                      ?>
                                                                        <div class="js-twer-color-picker-wrap twer-color-picker-wrap" <?php echo $data_template; ?>>
                                                                            <div class="map-text-color js-twer-color-picker">
                                                                                    <span class="color-holder"
                                                                                          style="background-color:<?php echo esc_attr( $field_group['value'] ) ?>;"></span>
                                                                                <input type="button"
                                                                                       class="text-color-picker-btn"
                                                                                       value="<?php echo esc_attr__( 'Select Color',
                                                                                         'treweler' ); ?>">
                                                                            </div>
                                                                            <!-- .color-picker-text-descr -->
                                                                            <div class="js-twer-color-picker-palette twer-color-picker-palette"
                                                                                 acp-color="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                 acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                                 default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                                 acp-show-rgb="no"
                                                                                 acp-show-hsl="no"
                                                                                 acp-palette-editable>
                                                                            </div>
                                                                            <input type="hidden"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="input-color input-color-field"

                                                                                   id="<?php echo esc_attr( $field_group['id'] ); ?>"
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>">
                                                                        </div>
                                                                      <?php
                                                                    } elseif ( 'textarea' === $field_group['type'] ) { ?>
                                                                        }
                                                                        <div class="twer-form-group twer-form-group--text">
                                                            <textarea class="large-text"
                                                                      name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                      id="<?php echo esc_attr( $element_id ); ?>"
                                                                      cols="30"
                                                                      <?php echo $data_template; ?>
                                                                      rows="6"><?php echo esc_attr( $field_group['value'] ) ?></textarea>
                                                                        </div>
                                                                    <?php }
                                                                    ?>
                                                                  </div>
                                                              <?php } ?>
                                                            </div>
                                                        </div>
                                                    <?php } ?>

                                                  </div>
                                              </td>
                                          </tr>
                                      <?php } ?>
                                    </table>
                                </div>
                            </div>

                            <div class="tab-pane fade" id="twer-nav-popup" role="tabpanel"
                                 aria-labelledby="twer-nav-popup-tab">
                                <div class="table-responsive">
                                    <table class="table twer-table twer-table--cells-2">
                                      <?php foreach (
                                        $fields_popup

                                        as $field
                                      ) {
                                        $element_id = trim( str_replace( '_', '-', $field['name'] ), '-' );

                                        $tr_class = [ 'twer-tr-toggle' ];
                                        $tr_atts = [];

                                        if ( isset( $field['toggle_row'] ) ) {
                                          $tr_class[] = 'js-twer-tr-toggle';


                                          if ( isset( $field['toggle_row']['related_id'] ) ) {
                                            $tr_atts[] = 'id="' . $field['toggle_row']['related_id'] . '-toggle"';
                                          }

                                          if ( isset( $field['toggle_row']['trigger'] ) ) {
                                            $tr_atts[] = 'data-trigger="' . $field['toggle_row']['trigger'] . '"';
                                          }
                                        }
                                        ?>
                                          <tr class="<?php echo esc_attr( implode( ' ',
                                            $tr_class ) ); ?>" <?php echo implode( ' ', $tr_atts ); ?>>
                                              <th class="th-<?php echo esc_attr( $element_id ); ?>">
                                                  <label for="<?php echo esc_attr( $element_id ) ?>"><?php echo esc_html( $field['label'] ); ?></label>
                                              </th>
                                              <td>
                                                <?php
                                                $data_template = isset( $field['data_template'] ) ? implode( ' ', $field['data_template'] ) : '';
                                                ?>
                                                  <div class="twer-wrap-fields">
                                                    <?php template_locks( $current_template, $field, $meta_data ); ?>

                                                    <?php if ( 'select' === $field['type'] ) { ?>
                                                        <div class="twer-form-group twer-form-group--select">
                                                            <select name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                    class="large-select"
                                                              <?php echo $data_template; ?>
                                                                    id="<?php echo esc_attr( $element_id ); ?>">
                                                              <?php foreach ( $field['value'] as $data ) { ?>
                                                                  <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                              <?php } ?>
                                                            </select>
                                                        </div>
                                                    <?php } elseif ( 'checkbox' === $field['type'] ) { ?>
                                                        <input type="hidden"
                                                               name="<?php echo esc_attr( $field['name'] ); ?>"
                                                               value="">
                                                      <?php foreach ( $field['value'] as $data ) { ?>
                                                            <label for="<?php echo esc_attr( $element_id ) ?>" class="twer-switcher" <?php echo $data_template; ?> >
                                                                <input type="checkbox"
                                                                       name="<?php echo esc_attr( $field['name'] ); ?>[]"
                                                                       id="<?php echo esc_attr( $element_id ); ?>"
                                                                       value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                <div class="twer-switcher__slider"></div>
                                                            </label>
                                                      <?php } ?>
                                                    <?php } elseif ( 'colorpicker' === $field['type'] ) { ?>
                                                        <div class="js-twer-color-picker-wrap twer-color-picker-wrap" <?php echo $data_template; ?>>
                                                            <div class="map-text-color js-twer-color-picker">
                                                                <span class="color-holder"
                                                                      style="background-color:<?php echo esc_attr( $field['value'] ) ?>;"></span>
                                                                <input type="button" class="text-color-picker-btn"
                                                                       value="<?php echo esc_attr__( 'Select Color',
                                                                         'treweler' ); ?>">
                                                            </div>
                                                            <!-- .color-picker-text-descr -->
                                                            <div class="js-twer-color-picker-palette twer-color-picker-palette"
                                                                 acp-color="<?php echo esc_attr( $field['value'] ) ?>"
                                                                 acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                 default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                 acp-show-rgb="no"
                                                                 acp-show-hsl="no"
                                                                 acp-palette-editable>
                                                            </div>
                                                            <input type="hidden"
                                                                   name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                   class="input-color input-color-field"
                                                                   value="<?php echo esc_attr( $field['value'] ) ?>">
                                                        </div>
                                                    <?php } elseif ( 'text' === $field['type'] || 'url' === $field['type'] ) {

                                                      $field_class = [ 'twer-form-group twer-form-group--text' ];
                                                      $field_placeholder = '';
                                                      if ( isset( $field['size'] ) ) {
                                                        $field_class[] = 'twer-form-group--' . $field['size'];
                                                      }

                                                      if ( isset( $field['placeholder'] ) ) {
                                                        $field_placeholder = $field['placeholder'];
                                                      }
                                                      if ( isset( $field['postfix'] ) ) {
                                                        $field_class[] = 'twer-form-group--append';
                                                      }

                                                      ?>
                                                        <div class="<?php echo esc_attr( implode( ' ', $field_class ) ); ?>">
                                                            <input type="<?php echo esc_attr( $field['type'] ); ?>"
                                                                   id="<?php echo esc_attr( $element_id ); ?>"
                                                                   name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                   class="large-text"
                                                              <?php echo $data_template; ?>
                                                                   value="<?php echo esc_attr( $field['value'] ) ?>"
                                                                   placeholder="<?php echo esc_attr( $field_placeholder ); ?>">
                                                          <?php if ( isset( $field['postfix'] ) ) { ?>
                                                              <div class="twer-form-group-append">
                                                                  <span class="twer-form-group-append__text"><?php echo esc_html( $field['postfix'] ); ?></span>
                                                              </div>
                                                          <?php } ?>
                                                        </div>
                                                    <?php } elseif ( 'textarea' === $field['type'] ) { ?>
                                                        <div class="twer-form-group twer-form-group--text">
                                                            <textarea class="large-text"
                                                                      name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                      id="<?php echo esc_attr( $element_id ); ?>"
                                                                      cols="30"
                                                                      <?php echo $data_template; ?>
                                                                      rows="6"><?php echo esc_attr( $field['value'] ) ?></textarea>
                                                        </div>
                                                    <?php } elseif ( 'image' === $field['type'] ) { ?>
                                                        <div class="twer-attach js-twer-attach-wrap" <?php echo $data_template; ?>>

                                                            <div class="twer-attach__thumb js-twer-attach-thumb">
                                                              <?php if ( $field['value'] ) { ?>
                                                                  <img src="<?php echo esc_url( $field['value'] ); ?>"
                                                                       alt="">
                                                              <?php } ?>
                                                                <button type="button"
                                                                        id="<?php echo esc_attr( $element_id ); ?>"
                                                                        style="<?php echo ! empty( $field['value'] ) ? 'display:none;' : 'display:block'; ?>"
                                                                        class="twer-attach__add-media js-twer-attach-add"><?php echo esc_html__( 'Select Image',
                                                                    'treweler' ); ?></button>

                                                                <input type="hidden"
                                                                       name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                       value="<?php echo esc_attr( $field['value'] ) ?>">
                                                            </div>

                                                            <div class="twer-attach__actions js-twer-attach-actions"
                                                                 style="<?php echo ! empty( $field['value'] ) ? 'display:block;' : 'display:none'; ?>">
                                                                <button type="button"
                                                                        class="button js-twer-attach-remove"><?php echo esc_html__( 'Remove',
                                                                    'treweler' ); ?></button>
                                                                <button type="button"
                                                                        class="button js-twer-attach-add"><?php echo esc_html__( 'Change image',
                                                                    'treweler' ); ?></button>
                                                            </div>
                                                        </div>
                                                    <?php } elseif ( 'gallery' === $field['type'] ) { ?>
                                                        <div class="twer-attach-gallery js-twer-attach-gallery-wrap" <?php echo $data_template; ?>>

                                                          <?php
                                                          $gallery_value = [];
                                                          if ( ! empty( $field['value'] ) ) {

                                                            if ( filter_var( $field['value'], FILTER_VALIDATE_URL ) ) {
                                                              $attachment_id = attachment_url_to_postid( $field['value'] );
                                                              $field['value'] = $attachment_id;
                                                              $thumbnail_img = wp_get_attachment_image( $attachment_id, 'full' );
                                                              if ( $thumbnail_img ) {
                                                                $gallery_value[] = $attachment_id;
                                                                echo '<div class="twer-attach-gallery__thumb" data-id="' . esc_attr( $attachment_id ) . '"><a href="#" class="twer-attach-gallery__remove js-twer-attach-gallery-remove" title="' . __( 'Remove', 'treweler' ) . '"></a>' . $thumbnail_img . '</div>';
                                                              }
                                                            } else {
                                                              $thumbnails_ids = explode( ',', $field['value'] );
                                                              if ( ! empty( $thumbnails_ids ) && is_array( $thumbnails_ids ) ) {
                                                                foreach ( $thumbnails_ids as $thumbnail_id ) {
                                                                  $thumbnail_img = wp_get_attachment_image( $thumbnail_id, 'full' );
                                                                  if ( $thumbnail_img ) {
                                                                    $gallery_value[] = $thumbnail_id;
                                                                    echo '<div class="twer-attach-gallery__thumb" data-id="' . esc_attr( $thumbnail_id ) . '"><a href="#" class="twer-attach-gallery__remove js-twer-attach-gallery-remove" title="' . __( 'Remove', 'treweler' ) . '"></a>' . $thumbnail_img . '</div>';
                                                                  }
                                                                }
                                                              }
                                                            }
                                                          } ?>

                                                            <button type="button" class="twer-attach-gallery__add-media js-twer-attach-gallery-add"></button>

                                                            <input type="hidden" id="<?php echo esc_attr( $field['id'] ); ?>" name="<?php echo esc_attr( $field['name'] ); ?>" value="<?php echo esc_attr( implode( ',', $gallery_value ) ) ?>">
                                                        </div>
                                                    <?php } elseif ( 'group' === $field['type'] ) { ?>
                                                        <div class="twer-group-elements">
                                                            <div class="row">
                                                              <?php foreach ( $field['value'] as $field_group ) {

                                                                $element_id_group = trim( str_replace( '_', '-',
                                                                  $field['name'] . '_' . $field_group['name'] ),
                                                                  '-' );
                                                                $field_group['name'] = $field['name'] . '[' . $field_group['name'] . ']';

                                                                $field_class = [];
                                                                if ( isset( $field_group['postfix'] ) ) {
                                                                  $field_class[] = 'twer-form-group--append';
                                                                }

                                                                $data_template = isset( $field_group['data_template'] ) ? implode( ' ', $field_group['data_template'] ) : '';
                                                                ?>
                                                                  <div class="<?php echo 'colorpicker' === $field_group['type'] ? 'col-simple' : 'col-fixed' ?>">
                                                                      <label for="<?php echo esc_attr( $element_id_group ); ?>"><?php echo esc_attr( $field_group['label'] ); ?></label>
                                                                    <?php if ( 'text' === $field_group['type'] || 'url' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--text <?php echo esc_attr( implode( ' ', $field_class ) ); ?>">
                                                                            <input type="<?php echo esc_attr( $field_group['type'] ); ?>"
                                                                                   id="<?php echo esc_attr( $element_id_group ); ?>"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="large-text"
                                                                              <?php echo $data_template; ?>
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>">
                                                                          <?php if ( isset( $field_group['postfix'] ) ) { ?>
                                                                              <div class="twer-form-group-append">
                                                                                  <span class="twer-form-group-append__text"><?php echo esc_html( $field_group['postfix'] ); ?></span>
                                                                              </div>
                                                                          <?php } ?>
                                                                        </div>


                                                                    <?php } elseif ( 'select' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--select">
                                                                            <select name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                    class="large-select"
                                                                              <?php echo $data_template; ?>
                                                                                    id="<?php echo esc_attr( $element_id_group ); ?>">
                                                                              <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                                  <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                              <?php } ?>
                                                                            </select>
                                                                        </div>


                                                                    <?php } elseif ( 'colorpicker' === $field_group['type'] ) { ?>
                                                                        <div class="js-twer-color-picker-wrap twer-color-picker-wrap" <?php echo $data_template; ?>>
                                                                            <div class="map-text-color js-twer-color-picker">
                                                                                    <span class="color-holder"
                                                                                          style="background-color:<?php echo esc_attr( $field_group['value'] ) ?>;"></span>
                                                                                <input type="button"
                                                                                       class="text-color-picker-btn"
                                                                                       value="<?php echo esc_attr__( 'Select Color',
                                                                                         'treweler' ); ?>">
                                                                            </div>
                                                                            <!-- .color-picker-text-descr -->
                                                                            <div class="js-twer-color-picker-palette twer-color-picker-palette"
                                                                                 acp-color="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                 acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                                 default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                                 acp-show-rgb="no"
                                                                                 acp-show-hsl="no"
                                                                                 acp-palette-editable>
                                                                            </div>
                                                                            <input type="hidden"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="input-color input-color-field"
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>">
                                                                        </div>
                                                                    <?php } elseif ( 'checkbox' === $field_group['type'] ) { ?>
                                                                        <input type="hidden"
                                                                               name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                               value="">
                                                                      <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                            <label for="<?php echo esc_attr( $element_id_group ) ?>" <?php echo $data_template; ?> class="twer-switcher">
                                                                                <input type="checkbox"
                                                                                       name="<?php echo esc_attr( $field_group['name'] ); ?>[]"
                                                                                       id="<?php echo esc_attr( $element_id_group ); ?>"
                                                                                       value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                                <div class="twer-switcher__slider"></div>
                                                                            </label>
                                                                      <?php } ?>
                                                                    <?php } ?>
                                                                  </div>
                                                              <?php } ?>
                                                            </div>
                                                        </div>
                                                    <?php } elseif ( 'group_simple' === $field['type'] ) { ?>
                                                        <div class="twer-group-elements">
                                                            <div class="row">
                                                              <?php
                                                              $simple_counter = 0;
                                                              foreach ( $field['value'] as $field_group ) {
                                                                $simple_counter ++;
                                                                $class_simple = '';
                                                                switch ( $simple_counter ) {
                                                                  case '1' :
                                                                    $class_simple = 'col-fixed--260';
                                                                    break;
                                                                  case '2' :
                                                                    $class_simple = 'col-fixed--130';
                                                                    break;
                                                                  case '3' :
                                                                    $class_simple = 'col-fixed--200';
                                                                    break;
                                                                }

                                                                $data_template = isset( $field_group['data_template'] ) ? implode( ' ', $field_group['data_template'] ) : '';
                                                                ?>
                                                                  <div class="<?php echo 'colorpicker' === $field_group['type'] ? 'col-simple' : 'col-fixed ' . $class_simple ?>">
                                                                    <?php if ( 'text' === $field_group['type'] || 'url' === $field_group['type'] ) {

                                                                      $field_group_class = [ 'twer-form-group twer-form-group--text' ];
                                                                      $field_group_placeholder = '';
                                                                      if ( isset( $field_group['size'] ) ) {
                                                                        $field_group_class[] = 'twer-form-group--' . $field_group['size'];
                                                                      }

                                                                      if ( isset( $field_group['placeholder'] ) ) {
                                                                        $field_group_placeholder = $field_group['placeholder'];
                                                                      }
                                                                      if ( isset( $field_group['postfix'] ) ) {
                                                                        $field_group_class[] = 'twer-form-group--append';
                                                                      }

                                                                      ?>
                                                                        <div class="<?php echo esc_attr( implode( ' ', $field_group_class ) ); ?>">
                                                                            <input type="<?php echo esc_attr( $field_group['type'] ); ?>"
                                                                                   id="<?php echo esc_attr( $element_id ); ?>"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="large-text"
                                                                              <?php echo $data_template; ?>
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                   placeholder="<?php echo esc_attr( $field_group_placeholder ); ?>">
                                                                          <?php if ( isset( $field_group['postfix'] ) ) { ?>
                                                                              <div class="twer-form-group-append">
                                                                                  <span class="twer-form-group-append__text"><?php echo esc_html( $field_group['postfix'] ); ?></span>
                                                                              </div>
                                                                          <?php } ?>
                                                                        </div>
                                                                    <?php } elseif ( 'select' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--select">
                                                                            <select name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                    class="large-select"
                                                                              <?php echo $data_template; ?>
                                                                                    id="<?php echo esc_attr( $element_id ); ?>">
                                                                              <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                                  <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                              <?php } ?>
                                                                            </select>
                                                                        </div>
                                                                    <?php } elseif ( 'textarea' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--text">
                                                            <textarea class="large-text"
                                                                      name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                      id="<?php echo esc_attr( $element_id ); ?>"
                                                                      cols="30"
                                                                      <?php echo $data_template; ?>
                                                                      rows="6"><?php echo esc_attr( $field_group['value'] ) ?></textarea>
                                                                        </div>
                                                                    <?php }
                                                                    ?>
                                                                  </div>
                                                              <?php } ?>
                                                            </div>
                                                        </div>
                                                    <?php } ?>
                                                  </div>
                                              </td>
                                          </tr>
                                      <?php } ?>
                                    </table>
                                </div>
                            </div>

                            <div class="tab-pane fade" id="twer-nav-clusters" role="tabpanel"
                                 aria-labelledby="twer-nav-clusters-tab">
                                <div class="table-responsive">
                                    <table class="table twer-table twer-table--cells-2">
                                        <tbody>
                                        <?php foreach ( $fields_clusters as $field ) {
                                          $element_id = trim( str_replace( '_', '-', $field['name'] ), '-' );
                                          ?>
                                            <tr>
                                                <th>
                                                    <label for="<?php echo esc_attr( $element_id ); ?>">
                                                      <?php echo esc_html( $field['label'] ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                  <?php
                                                  $data_template = isset( $field['data_template'] ) ? implode( ' ', $field['data_template'] ) : '';
                                                  ?>
                                                    <div class="twer-wrap-fields">
                                                      <?php template_locks( $current_template, $field, $meta_data ); ?>
                                                      <?php if ( 'checkbox' === $field['type'] ) { ?>
                                                          <input type="hidden"
                                                                 name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                 value="">
                                                        <?php foreach ( $field['value'] as $data ) { ?>
                                                              <label for="<?php echo esc_attr( $element_id ) ?>" <?php echo $data_template; ?> class="twer-switcher">
                                                                  <input type="checkbox"
                                                                         name="<?php echo esc_attr( $field['name'] ); ?>[]"
                                                                         id="<?php echo esc_attr( $element_id ); ?>"
                                                                         value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                  <div class="twer-switcher__slider"></div>
                                                              </label>
                                                        <?php } ?>
                                                      <?php } ?>
                                                    </div>
                                                </td>
                                            </tr>
                                        <?php } ?>
                                        </tbody>
                                    </table>
                                </div>
                            </div>

                            <div class="tab-pane fade" id="twer-nav-labels" role="tabpanel"
                                 aria-labelledby="twer-nav-labels-tab">
                                <div class="table-responsive">
                                    <table class="table twer-table twer-table--cells-2">
                                        <tbody>
                                        <?php foreach ( $fields_labels as $field ) {
                                          $element_id = trim( str_replace( '_', '-', $field['name'] ), '-' );
                                          $tr_class_label = isset($field['row_class']) ? $field['row_class'] : '';
                                          $tr_atts = isset($field['row_atts']) ? $field['row_atts'] : '';
                                          ?>
                                            <tr <?php echo $tr_atts; ?> class="<?php echo esc_attr($tr_class_label); ?>" >
                                                <th>
                                                    <label for="<?php echo esc_attr( $element_id ); ?>">
                                                      <?php echo esc_html( $field['label'] ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                  <?php
                                                  $data_template = isset( $field['data_template'] ) ? implode( ' ', $field['data_template'] ) : '';
                                                  ?>
                                                    <div class="twer-wrap-fields">
                                                      <?php template_locks( $current_template, $field, $meta_data ); ?>
                                                      <?php if ( 'select' === $field['type'] ) { ?>
                                                          <div class="twer-form-group twer-form-group--select">
                                                              <select name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                      id="<?php echo esc_attr( $element_id ); ?>"
                                                                <?php echo $data_template; ?>
                                                                      class="large-select">
                                                                <?php foreach ( $field['value'] as $value => $data ) {


                                                                  ?>
                                                                    <option value="<?php echo esc_attr( $data['value'] ); ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                <?php } ?>
                                                              </select>
                                                          </div>
                                                      <?php }  elseif ( 'group' === $field['type'] ) { ?>
                                                        <div class="twer-group-elements">
                                                            <div class="row">
                                                              <?php foreach ( $field['value'] as $field_group ) {

                                                                $element_id_group = trim( str_replace( '_', '-',
                                                                  $field['name'] . '_' . $field_group['name'] ),
                                                                  '-' );
                                                                $field_group['name'] = $field['name'] . '[' . $field_group['name'] . ']';

                                                                $field_class = [];
                                                                if ( isset( $field_group['postfix'] ) ) {
                                                                  $field_class[] = 'twer-form-group--append';
                                                                }
                                                                $field_group_placeholder = '';
                                                                if ( isset( $field_group['placeholder'] ) ) {
                                                                  $field_group_placeholder = $field_group['placeholder'];
                                                                }

                                                                $data_template = isset( $field_group['data_template'] ) ? implode( ' ', $field_group['data_template'] ) : '';
                                                                ?>
                                                                  <div class="<?php echo 'colorpicker' === $field_group['type'] ? 'col-simple' : 'col-fixed col-fixed--130' ?>">
                                                                      <label for="<?php echo esc_attr( $element_id_group ); ?>"><?php echo esc_attr( $field_group['label'] ); ?></label>
                                                                    <?php if ( 'text' === $field_group['type'] || 'url' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--text <?php echo esc_attr( implode( ' ', $field_class ) ); ?>">
                                                                            <input type="<?php echo esc_attr( $field_group['type'] ); ?>"
                                                                                   id="<?php echo esc_attr( $element_id_group ); ?>"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="large-text"
                                                                                   placeholder="<?php echo esc_attr( $field_group_placeholder ); ?>"
                                                                              <?php echo $data_template; ?>
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>">
                                                                          <?php if ( isset( $field_group['postfix'] ) ) { ?>
                                                                              <div class="twer-form-group-append">
                                                                                  <span class="twer-form-group-append__text"><?php echo esc_html( $field_group['postfix'] ); ?></span>
                                                                              </div>
                                                                          <?php } ?>
                                                                        </div>


                                                                    <?php } elseif ( 'select' === $field_group['type'] ) { ?>
                                                                        <div class="twer-form-group twer-form-group--select">
                                                                            <select name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                    class="large-select"
                                                                              <?php echo $data_template; ?>
                                                                                    id="<?php echo esc_attr( $element_id_group ); ?>">
                                                                              <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                                  <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                              <?php } ?>
                                                                            </select>
                                                                        </div>


                                                                    <?php } elseif ( 'colorpicker' === $field_group['type'] ) { ?>
                                                                        <div class="js-twer-color-picker-wrap twer-color-picker-wrap" <?php echo $data_template; ?>>
                                                                            <div class="map-text-color js-twer-color-picker">
                                                                                    <span class="color-holder"
                                                                                          style="background-color:<?php echo esc_attr( $field_group['value'] ) ?>;"></span>
                                                                                <input type="button"
                                                                                       class="text-color-picker-btn"
                                                                                       value="<?php echo esc_attr__( 'Select Color',
                                                                                         'treweler' ); ?>">
                                                                            </div>
                                                                            <!-- .color-picker-text-descr -->
                                                                            <div class="js-twer-color-picker-palette twer-color-picker-palette"
                                                                                 acp-color="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                 acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                                 default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                                 acp-show-rgb="no"
                                                                                 acp-show-hsl="no"
                                                                                 acp-palette-editable>
                                                                            </div>
                                                                            <input type="hidden"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   class="input-color input-color-field"
                                                                                   value="<?php echo esc_attr( $field_group['value'] ) ?>">
                                                                        </div>
                                                                    <?php } elseif ( 'checkbox' === $field_group['type'] ) { ?>
                                                                        <input type="hidden"
                                                                               name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                               value="">
                                                                      <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                            <label for="<?php echo esc_attr( $element_id_group ) ?>" <?php echo $data_template; ?> class="twer-switcher">
                                                                                <input type="checkbox"
                                                                                       name="<?php echo esc_attr( $field_group['name'] ); ?>[]"
                                                                                       id="<?php echo esc_attr( $element_id_group ); ?>"
                                                                                       value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                                <div class="twer-switcher__slider"></div>
                                                                            </label>
                                                                      <?php } ?>
                                                                    <?php } ?>
                                                                  </div>
                                                              <?php } ?>
                                                            </div>
                                                        </div>
                                                        <?php } elseif ( 'text' === $field['type'] ) {

                                                        $field_class = [ 'twer-form-group twer-form-group--text' ];
                                                        $field_placeholder = '';
                                                        if ( isset( $field['size'] ) ) {
                                                          $field_class[] = 'twer-form-group--' . $field['size'];
                                                        }

                                                        if ( isset( $field['placeholder'] ) ) {
                                                          $field_placeholder = $field['placeholder'];
                                                        }
                                                        if ( isset( $field['postfix'] ) ) {
                                                          $field_class[] = 'twer-form-group--append';
                                                        }

                                                        ?>
                                                          <div class="<?php echo esc_attr( implode( ' ', $field_class ) ); ?>">
                                                              <input type="text"
                                                                     name="<?php echo esc_attr( $field['name'] ) ?>"
                                                                     id="<?php echo esc_attr( $element_id ); ?>"
                                                                     class="large-text"
                                                                <?php echo $data_template; ?>
                                                                     value="<?php echo esc_attr( htmlspecialchars( $field['value'] ) ) ?>"
                                                                     placeholder="<?php echo esc_attr( $field_placeholder ); ?>"
                                                              >
                                                            <?php if ( isset( $field['postfix'] ) ) { ?>
                                                                <div class="twer-form-group-append">
                                                                    <span class="twer-form-group-append__text"><?php echo esc_html( $field['postfix'] ); ?></span>
                                                                </div>
                                                            <?php } ?>
                                                            <?php if ( ! empty( $field['help'] ) ) { ?>
                                                                <a href="#" class="twer-help-tooltip"
                                                                   data-toggle="tooltip"
                                                                   title="<?php echo esc_attr( $field['help'] ); ?>"><span
                                                                            class="dashicons dashicons-editor-help"></span></a>
                                                            <?php } ?>
                                                          </div>
                                                      <?php } elseif ( 'textarea' === $field['type'] ) { ?>
                                                          <div class="twer-form-group twer-form-group--text">
                                                            <textarea class="large-text"
                                                                      name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                      id="<?php echo esc_attr( $element_id ); ?>"
                                                                      cols="30"
                                                                      <?php echo $data_template; ?>
                                                                      rows="6"><?php echo esc_attr( $field['value'] ) ?></textarea>
                                                          </div>
                                                      <?php } elseif ( 'colorpicker' === $field['type'] ) { ?>
                                                          <div class="js-twer-color-picker-wrap twer-color-picker-wrap" <?php echo $data_template; ?>>
                                                              <div class="map-text-color js-twer-color-picker">
                                                                <span class="color-holder"
                                                                      style="background-color:<?php echo esc_attr( $field['value'] ) ?>;"></span>
                                                                  <input type="button" class="text-color-picker-btn"
                                                                         value="<?php echo esc_attr__( 'Select Color',
                                                                           'treweler' ); ?>">
                                                              </div>
                                                              <!-- .color-picker-text-descr -->
                                                              <div class="js-twer-color-picker-palette twer-color-picker-palette"
                                                                   acp-color="<?php echo esc_attr( $field['value'] ) ?>"
                                                                   acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                   default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                   acp-show-rgb="no"
                                                                   acp-show-hsl="no"
                                                                   acp-palette-editable>
                                                              </div>
                                                              <input type="hidden"
                                                                     name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                     class="input-color input-color-field"
                                                                     id="<?php echo esc_attr( $field['id'] ); ?>"
                                                                     value="<?php echo esc_attr( $field['value'] ) ?>">
                                                          </div>
                                                      <?php } elseif ( 'checkbox' === $field['type'] ) { ?>
                                                          <input type="hidden"
                                                                 name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                 value="">
                                                        <?php foreach ( $field['value'] as $data ) { ?>
                                                              <label for="<?php echo esc_attr( $element_id ) ?>" <?php echo $data_template; ?>
                                                                     class="twer-switcher">
                                                                  <input type="checkbox"
                                                                         name="<?php echo esc_attr( $field['name'] ); ?>[]"
                                                                         id="<?php echo esc_attr( $element_id ); ?>"
                                                                         value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                  <div class="twer-switcher__slider"></div>
                                                              </label>
                                                        <?php } ?>
                                                      <?php } ?>
                                                    </div>
                                                </td>
                                            </tr>
                                        <?php } ?>
                                        </tbody>
                                    </table>
                                </div>
                            </div>


                          <?php if ( ! empty( $all_custom_fields ) ) { ?>
                              <div class="tab-pane fade" id="twer-nav-custom-fields" role="tabpanel"
                                   aria-labelledby="twer-nav-custom-fields-tab">
                                  <div class="table-responsive">
                                      <table class="table twer-table twer-table--cells-2">
                                          <tbody class="js-ui-slider-wrap">
                                          <?php foreach (
                                            $fields_custom

                                            as $field
                                          ) {
                                            $element_id = trim( str_replace( '_', '-', $field['name'] ), '-' );


                                            $tr_class = [ 'twer-tr-toggle' ];
                                            $tr_atts = [];

                                            if ( isset( $field['toggle_row'] ) ) {
                                              $tr_class[] = 'js-twer-tr-toggle';


                                              if ( isset( $field['toggle_row']['related_id'] ) ) {
                                                $tr_atts[] = 'id="' . $field['toggle_row']['related_id'] . '-toggle"';
                                              }

                                              if ( isset( $field['toggle_row']['trigger'] ) ) {
                                                $tr_atts[] = 'data-trigger="' . $field['toggle_row']['trigger'] . '"';
                                              }
                                            }

                                            if ( isset( $field['tr-class'] ) ) {
                                              $tr_class[] = $field['tr-class'];
                                            }

                                            $tr_id = '';
                                            if ( isset( $field['tr-id'] ) ) {
                                              $tr_id = 'data-id="' . $field['tr-id'] . '"';
                                            }
                                            ?>
                                              <tr <?php echo $tr_id; ?> class="<?php echo esc_attr( implode( ' ',
                                                $tr_class ) ); ?>" <?php echo implode( ' ', $tr_atts ); ?>>
                                                  <th class="th-<?php echo esc_attr( $element_id ); ?>">
                                                      <label for="<?php echo esc_attr( $element_id ) ?>"><?php echo esc_html( $field['label'] ); ?></label>
                                                  </th>
                                                  <td>
                                                    <?php
                                                    $data_template = isset( $field['data_template'] ) ? implode( ' ', $field['data_template'] ) : '';
                                                    ?>
                                                      <div class="twer-wrap-fields">

                                                        <?php if ( isset( $field['tr-id'] ) ) {


                                                          $action_class = 'none' === $current_template ? '' : 'd-none';
                                                          $action_style = 'none' === $current_template ? '' : 'style="right:0;"';
                                                          echo '<a href="#" class="js-twer-ui-del-tr twer-ui-del-tr ' . $action_class . '"></a> <a href="#" class="js-twer-ui-sort-tr twer-ui-sort-tr ' . $action_class . '"></a>';


                                                          if ( ! empty( $field['lock_fields'] ) ) {

                                                            if ( isset( $field['lock_open'] ) ) {
                                                              $locked = $field['lock_open'] ? 'twer-lock--open' : '';

                                                              ?>
                                                                <div class="twer-defaults" <?php echo $action_style; ?>>
                                                                  <?php for ( $i = 0; $i < $field['lock_fields']; $i ++ ) {
                                                                    ?>
                                                                      <a href="#" class="twer-lock <?php echo esc_attr( $locked ); ?> js-twer-lock" title=""></a>
                                                                  <?php } ?>
                                                                </div>
                                                              <?php
                                                            } else {
                                                              $field_gr = $field['value'];
                                                              ?>
                                                                <div class="twer-defaults" <?php echo $action_style; ?>>
                                                                  <?php foreach ( $field_gr as $gr ) {
                                                                    $locked = $gr['lock_open'] ? 'twer-lock--open' : '';
                                                                    ?>
                                                                      <a href="#" class="twer-lock <?php echo esc_attr( $locked ); ?> js-twer-lock" title=""></a>
                                                                  <?php } ?>
                                                                </div>
                                                              <?php
                                                            }
                                                          }
                                                        } else {

                                                          template_locks( $current_template, $field, $meta_data );
                                                        } ?>
                                                        <?php
                                                        if ( 'select' === $field['type'] ) { ?>
                                                            <div class="twer-form-group twer-form-group--select">
                                                                <select name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                        class="large-select"
                                                                  <?php echo isset( $field['tr-id'] ) ? '' : $data_template; ?>
                                                                        id="<?php echo esc_attr( $element_id ); ?>">
                                                                  <?php foreach ( $field['value'] as $data ) { ?>
                                                                      <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                  <?php } ?>
                                                                </select>
                                                            </div>
                                                        <?php } elseif ( 'checkbox' === $field['type'] ) { ?>
                                                            <input type="hidden"
                                                                   name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                   value="">
                                                          <?php foreach ( $field['value'] as $data ) { ?>

                                                                <label for="<?php echo esc_attr( $element_id ) ?>" <?php echo isset( $field['tr-id'] ) ? '' : $data_template; ?> class="twer-switcher">
                                                                    <input type="checkbox"
                                                                           name="<?php echo esc_attr( $field['name'] ); ?>[]"
                                                                           id="<?php echo esc_attr( $element_id ); ?>"
                                                                           value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                    <div class="twer-switcher__slider"></div>
                                                                </label>
                                                          <?php } ?>
                                                        <?php } elseif ( 'text' === $field['type'] || 'url' === $field['type'] || 'email' === $field['type'] || 'tel' === $field['type'] ) {

                                                          $field_class = [ 'twer-form-group twer-form-group--text' ];
                                                          $field_placeholder = '';
                                                          if ( isset( $field['size'] ) ) {
                                                            $field_class[] = 'twer-form-group--' . $field['size'];
                                                          }

                                                          if ( isset( $field['placeholder'] ) ) {
                                                            $field_placeholder = $field['placeholder'];
                                                          }
                                                          if ( isset( $field['postfix'] ) ) {
                                                            $field_class[] = 'twer-form-group--append';
                                                          }

                                                          $class = 'large-text';
                                                          if ( isset( $field['class'] ) ) {
                                                            $class .= ' ' . $field['class'];
                                                          }

                                                          $subtype = '';
                                                          if ( isset( $field['subtype'] ) ) {
                                                            $subtype = $field['subtype'];
                                                          } else {
                                                            $subtype = $field['type'];
                                                          }

                                                          $field_disabled = isset( $field['disabled'] ) ? $field['disabled'] : '';
                                                          $field_readonly = isset( $field['readonly'] ) ? $field['readonly'] : '';
                                                          $data_values = isset( $field['data_atts'] ) ? $field['data_atts'] : '';
                                                          ?>
                                                            <div class="<?php echo esc_attr( implode( ' ', $field_class ) ); ?>">

                                                              <?php if ( ! empty( $field['lock_fields'] ) ) { ?>
                                                                  <input type="hidden" class="js-twer-lock-status" name="<?php echo esc_attr( $field['lock_name'] ); ?>" value="<?php echo esc_attr( $field['lock_value'] ) ?>" <?php echo $field_disabled; ?>>
                                                              <?php } ?>
                                                                <input type="<?php echo esc_attr( $subtype ); ?>"
                                                                       id="<?php echo esc_attr( $element_id ); ?>"
                                                                       name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                       class="<?php echo esc_attr( $class ); ?>"
                                                                       value="<?php echo esc_attr( $field['value'] ) ?>"
                                                                  <?php echo isset( $field['tr-id'] ) ? '' : $data_template; ?>

                                                                       placeholder="<?php echo esc_attr( $field_placeholder ); ?>" <?php echo $field_disabled; ?> <?php echo $field_readonly; ?>

                                                                  <?php echo $data_values; ?>
                                                                >
                                                              <?php if ( isset( $field['postfix'] ) ) { ?>
                                                                  <div class="twer-form-group-append">
                                                                      <span class="twer-form-group-append__text"><?php echo esc_html( $field['postfix'] ); ?></span>
                                                                  </div>
                                                              <?php } ?>
                                                            </div>
                                                        <?php } elseif ( 'group' === $field['type'] ) {

                                                          ?>
                                                            <div class="twer-group-elements">

                                                                <div class="row">
                                                                  <?php foreach ( $field['value'] as $field_group ) {

                                                                    $element_id_group = trim( str_replace( '_', '-',
                                                                      $field['name'] . '_' . $field_group['name'] ),
                                                                      '-' );
                                                                    $field_group['name'] = $field['name'] . '[' . $field_group['name'] . ']';

                                                                    $field_class = [];
                                                                    if ( isset( $field_group['postfix'] ) ) {
                                                                      $field_class[] = 'twer-form-group--append';
                                                                    }
                                                                    $data_template = isset( $field_group['data_template'] ) ? implode( ' ', $field_group['data_template'] ) : '';
                                                                    ?>
                                                                      <div class="<?php echo 'colorpicker' === $field_group['type'] ? 'col-simple' : 'col-fixed' ?>">
                                                                        <?php if ( ! empty( $field_group['label'] ) ) {
                                                                          $class = '';
                                                                          if ( $field_group['place'] === 'inline' ) {
                                                                            $class = 'class="d-inline-block mb-0 mr-1"';
                                                                          }
                                                                          ?>
                                                                            <label <?php echo $class; ?> for="<?php echo esc_attr( $element_id_group ); ?>"><?php echo esc_attr( $field_group['label'] ); ?></label>
                                                                        <?php } ?>
                                                                        <?php if ( 'text' === $field_group['type'] || 'url' === $field_group['type'] || 'email' === $field_group['type'] || 'tel' === $field_group['type'] ) {
                                                                          $field_placeholder = '';
                                                                          if ( isset( $field_group['placeholder'] ) ) {
                                                                            $field_placeholder = $field_group['placeholder'];
                                                                          }

                                                                          $field_disabled = isset( $field_group['disabled'] ) ? $field_group['disabled'] : '';
                                                                          $field_readonly = isset( $field_group['readonly'] ) ? $field_group['readonly'] : '';
                                                                          $data_values = isset( $field_group['data_atts'] ) ? $field_group['data_atts'] : '';
                                                                          ?>
                                                                            <div class="twer-form-group twer-form-group--text <?php echo esc_attr( implode( ' ', $field_class ) ); ?>">

                                                                              <?php
                                                                              if ( ! empty( $field_group['lock_fields'] ) ) {

                                                                                ?>
                                                                                  <input type="hidden" class="js-twer-lock-status" name="<?php echo esc_attr( $field_group['lock_name'] ); ?>" value="<?php echo esc_attr( $field_group['lock_value'] ) ?>" <?php echo $field_disabled; ?>>
                                                                              <?php } ?>

                                                                                <input type="<?php echo esc_attr( $field_group['type'] ); ?>"
                                                                                       id="<?php echo esc_attr( $element_id_group ); ?>"
                                                                                       name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                       class="large-text"
                                                                                       value="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                       placeholder="<?php echo esc_attr( $field_placeholder ); ?>"
                                                                                  <?php echo $field_disabled; ?>
                                                                                  <?php echo $data_values; ?>
                                                                                  <?php echo $field_readonly; ?>
                                                                                  <?php echo $data_template; ?>
                                                                                >
                                                                              <?php if ( isset( $field_group['postfix'] ) ) { ?>
                                                                                  <div class="twer-form-group-append">
                                                                                      <span class="twer-form-group-append__text"><?php echo esc_html( $field_group['postfix'] ); ?></span>
                                                                                  </div>
                                                                              <?php } ?>
                                                                            </div>


                                                                        <?php } elseif ( 'select' === $field_group['type'] ) { ?>
                                                                            <div class="twer-form-group twer-form-group--select">
                                                                                <select name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                        class="large-select"
                                                                                  <?php echo $data_template; ?>
                                                                                        id="<?php echo esc_attr( $element_id_group ); ?>">
                                                                                  <?php foreach ( $field_group['value'] as $data ) { ?>
                                                                                      <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                                  <?php } ?>
                                                                                </select>
                                                                            </div>


                                                                        <?php } elseif ( 'colorpicker' === $field_group['type'] ) { ?>
                                                                            <div class="js-twer-color-picker-wrap twer-color-picker-wrap" <?php echo $data_template; ?>>
                                                                                <div class="map-text-color js-twer-color-picker">
                                                                                    <span class="color-holder"
                                                                                          style="background-color:<?php echo esc_attr( $field_group['value'] ) ?>;"></span>
                                                                                    <input type="button"
                                                                                           class="text-color-picker-btn"
                                                                                           value="<?php echo esc_attr__( 'Select Color',
                                                                                             'treweler' ); ?>">
                                                                                </div>
                                                                                <!-- .color-picker-text-descr -->
                                                                                <div class="js-twer-color-picker-palette twer-color-picker-palette"
                                                                                     acp-color="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                     acp-palette="<?php echo esc_attr( $defaultColors . $custom_color ); ?>"
                                                                                     default-palette="<?php echo esc_attr( $defaultColors ); ?>"
                                                                                     acp-show-rgb="no"
                                                                                     acp-show-hsl="no"
                                                                                     acp-palette-editable>
                                                                                </div>
                                                                                <input type="hidden"
                                                                                       name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                       class="input-color input-color-field"
                                                                                       value="<?php echo esc_attr( $field_group['value'] ) ?>">
                                                                            </div>
                                                                        <?php } elseif ( 'checkbox' === $field_group['type'] ) {

                                                                          $field_disabled = isset( $field_group['disabled'] ) ? $field_group['disabled'] : '';
                                                                          $field_readonly = isset( $field_group['readonly'] ) ? $field_group['readonly'] : '';
                                                                          $data_values = isset( $field_group['data_atts'] ) ? $field_group['data_atts'] : '';
                                                                          ?>
                                                                          <?php if ( ! empty( $field_group['lock_fields'] ) ) { ?>
                                                                                <input type="hidden" class="js-twer-lock-status" name="<?php echo esc_attr( $field_group['lock_name'] ); ?>" value="<?php echo esc_attr( $field_group['lock_value'] ) ?>" <?php echo $field_disabled; ?>>
                                                                          <?php } ?>

                                                                            <input type="hidden"
                                                                                   name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                   value="" <?php echo $field_disabled; ?> <?php echo $field_readonly; ?> <?php echo $data_values; ?>>
                                                                          <?php foreach ( $field_group['value'] as $data ) { ?>

                                                                                <label for="<?php echo esc_attr( $element_id_group ) ?>" <?php echo $data_template; ?>
                                                                                       class="twer-switcher">
                                                                                    <input type="checkbox"
                                                                                      <?php echo $data_values; ?>
                                                                                      <?php echo $field_disabled; ?>
                                                                                      <?php echo $field_readonly; ?>
                                                                                           name="<?php echo esc_attr( $field_group['name'] ); ?>[]"
                                                                                           id="<?php echo esc_attr( $element_id_group ); ?>"
                                                                                           value="<?php echo esc_attr( $data['value'] ) ?>" <?php checked( $data['checked'] ); ?>><?php echo esc_html( $data['label'] ); ?>
                                                                                    <div class="twer-switcher__slider"></div>
                                                                                </label>
                                                                          <?php } ?>
                                                                        <?php } ?>
                                                                      </div>
                                                                  <?php } ?>
                                                                </div>
                                                            </div>
                                                        <?php } elseif ( 'group_simple' === $field['type'] ) { ?>
                                                            <div class="twer-group-elements">
                                                                <div class="row">
                                                                  <?php
                                                                  $simple_counter = 0;
                                                                  foreach ( $field['value'] as $field_group ) {
                                                                    $simple_counter ++;
                                                                    $class_simple = '';


                                                                    if ( isset( $field_group['class_value'] ) ) {
                                                                      $class_simple = $field_group['class_value'];
                                                                    } else {
                                                                      switch ( $simple_counter ) {
                                                                        case '1' :
                                                                          $class_simple = 'col-fixed--130';
                                                                          break;
                                                                        case '2' :
                                                                          $class_simple = 'col-fixed--200';
                                                                          break;
                                                                        case '3' :
                                                                          $class_simple = 'col-fixed--200';
                                                                          break;
                                                                      }
                                                                    }
                                                                    $data_template = isset( $field_group['data_template'] ) ? implode( ' ', $field_group['data_template'] ) : '';
                                                                    ?>
                                                                      <div class="<?php echo 'colorpicker' === $field_group['type'] ? 'col-simple' : 'col-fixed ' . $class_simple ?>">
                                                                        <?php

                                                                        if ( 'button' === $field_group['type'] ) {
                                                                          echo '<a href="#" class="button button-primary ' . esc_attr( $field_group['class'] ) . '" title="' . esc_attr( $field_group['label'] ) . '">' . esc_html( $field_group['label'] ) . '</a>';
                                                                        } elseif ( 'text' === $field_group['type'] || 'url' === $field_group['type'] ) {

                                                                          $field_group_class = [ 'twer-form-group twer-form-group--text' ];
                                                                          $field_group_placeholder = '';
                                                                          if ( isset( $field_group['size'] ) ) {
                                                                            $field_group_class[] = 'twer-form-group--' . $field_group['size'];
                                                                          }

                                                                          if ( isset( $field_group['placeholder'] ) ) {
                                                                            $field_group_placeholder = $field_group['placeholder'];
                                                                          }
                                                                          if ( isset( $field_group['postfix'] ) ) {
                                                                            $field_group_class[] = 'twer-form-group--append';
                                                                          }

                                                                          ?>
                                                                            <div class="<?php echo esc_attr( implode( ' ', $field_group_class ) ); ?>">
                                                                                <input type="<?php echo esc_attr( $field_group['type'] ); ?>"
                                                                                       id="<?php echo esc_attr( $element_id ); ?>"
                                                                                       name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                       class="large-text"
                                                                                  <?php echo $data_template; ?>
                                                                                       value="<?php echo esc_attr( $field_group['value'] ) ?>"
                                                                                       placeholder="<?php echo esc_attr( $field_group_placeholder ); ?>">
                                                                              <?php if ( isset( $field_group['postfix'] ) ) { ?>
                                                                                  <div class="twer-form-group-append">
                                                                                      <span class="twer-form-group-append__text"><?php echo esc_html( $field_group['postfix'] ); ?></span>
                                                                                  </div>
                                                                              <?php } ?>
                                                                            </div>
                                                                        <?php } elseif ( 'select' === $field_group['type'] ) { ?>
                                                                            <div class="twer-form-group twer-form-group--select">
                                                                                <select name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                                        class="large-select"
                                                                                  <?php echo $data_template; ?>
                                                                                        id="<?php echo esc_attr( $element_id ); ?>">
                                                                                  <?php foreach ( $field_group['value'] as $data ) {
                                                                                    if ( isset( $data['default'] ) ) {
                                                                                      ?>
                                                                                        <option value="<?php echo esc_attr( $data['value'] ) ?>"><?php echo esc_html( $data['label'] ); ?></option>
                                                                                      <?php
                                                                                    } else {
                                                                                      ?>
                                                                                        <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                                      <?php
                                                                                    }
                                                                                  } ?>
                                                                                </select>
                                                                            </div>
                                                                        <?php } elseif ( 'textarea' === $field_group['type'] ) { ?>
                                                                            <div class="twer-form-group twer-form-group--text">
                                                            <textarea class="large-text"
                                                                      name="<?php echo esc_attr( $field_group['name'] ); ?>"
                                                                      id="<?php echo esc_attr( $element_id ); ?>"
                                                                      cols="30"
                                                                      rows="6"><?php echo esc_attr( $field_group['value'] ) ?></textarea>
                                                                            </div>
                                                                        <?php }
                                                                        ?>
                                                                      </div>
                                                                  <?php } ?>
                                                                </div>
                                                            </div>
                                                        <?php } ?>
                                                      </div>
                                                  </td>
                                              </tr>
                                          <?php } ?>
                                          </tbody>
                                      </table>
                                  </div>
                              </div>

                          <?php } ?>


                            <div class="tab-pane fade" id="twer-nav-template" role="tabpanel"
                                 aria-labelledby="twer-nav-template-tab">
                                <div class="table-responsive">
                                    <table class="table twer-table twer-table--cells-2">
                                        <tbody>
                                        <?php foreach (
                                          $templates

                                          as $field
                                        ) {
                                          $element_id = trim( str_replace( '_', '-', $field['name'] ), '-' );


                                          $tr_class = [ 'twer-tr-toggle' ];
                                          $tr_atts = [];

                                          ?>
                                            <tr class="<?php echo esc_attr( implode( ' ',
                                              $tr_class ) ); ?>" <?php echo implode( ' ', $tr_atts ); ?>>
                                                <th class="th-<?php echo esc_attr( $element_id ); ?>">
                                                    <label for="<?php echo esc_attr( $element_id ) ?>"><?php echo esc_html( $field['label'] ); ?></label>
                                                </th>
                                                <td>
                                                    <div class="twer-wrap-fields">
                                                      <?php
                                                      if ( 'select' === $field['type'] ) { ?>
                                                          <div class="twer-form-group twer-form-group--select">
                                                              <select name="<?php echo esc_attr( $field['name'] ); ?>"
                                                                      class="large-select"
                                                                      id="<?php echo esc_attr( $element_id ); ?>">
                                                                <?php foreach ( $field['value'] as $data ) { ?>
                                                                    <option value="<?php echo esc_attr( $data['value'] ) ?>" <?php selected( $data['selected'] ); ?>><?php echo esc_html( $data['label'] ); ?></option>
                                                                <?php } ?>
                                                              </select>
                                                          </div>
                                                      <?php } ?>
                                                    </div>
                                                </td>
                                            </tr>
                                        <?php } ?>
                                        </tbody>
                                    </table>
                                </div>
                            </div>


                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

